package ru.ispras.telecomtesk.eap;

public class ConvertTypes {

	static public byte[] hton(long x) {
		byte[] res = new byte[8];
		for (int i = 0; i < 8; i++)
		{
			res[i] = (new Long(x >>> 56)).byteValue();
			x <<= 8;
		}
		return res;
	}

	static public byte[] hton(int x) {
		byte[] res = new byte[4];
		for (int i = 0; i < 4; i++)
		{
			res[i] = (new Integer(x >>> 24)).byteValue();
			x <<= 8;
		}
		return res;
	}

	static public byte[] hton(short x) {
		byte[] res = new byte[2];
		res[0] = (byte)(x >>> 8);
		res[1] = (byte)x;
		return res;
	}

	// byte array up to 4 bytes long will be converted
	static public int ntoh(byte[] x)
	{
		int res = 0, i = 0;
		for (; i < 4 && i < x.length; i++)
		{
			res <<= 8;
			res |= (x[i] & 0xFF);
		}
		return res;
	}

	static public int ntoh(byte[] x, int pos)
	{
		int res = 0, i = 0;
		for (; i < 4 && i+pos < x.length; i++)
		{
			res <<= 8;
			res |= (x[i+pos] & 0xFF);
		}
		return res;
	}

	// byte array up to len bytes long will be converted beginning from position pos
	static public int ntoh(byte[] x, int pos, int len) {
    	int res = 0;
    	while(len-- > 0) {
    		res <<= 8;
    		res |= (x[pos++] & 0xFF);
    	}
    	return res;
    }

	// byte array up to 2 bytes long will be converted
	static public short ntohs(byte[] x)
	{
		short res = 0;
		if(x.length >= 2) {
				res = (short)(x[0] & 0xFF);
				res <<= 8;
				res |= (x[1] & 0xFF);
		}
		return res;
	}

	static public short ntohs(byte[] x, int pos)
	{
		short res = 0;
		if((pos >= 0)&&(x.length >= pos + 2)) {
				res = (short)(x[pos++] & 0xFF);
				res <<= 8;
				res |= (x[pos] & 0xFF);
		}
		return res;
	}

	static public int int24bits(int a)
	{
		a &= 0x00ffffff;
		return a;
	}

	static public int unsignedByteToInt(byte b)
	{
		return (int) b & 0xFF;
	}
}