package ru.ispras.telecomtesk.eap.EAPPEAP;

import ru.ispras.telecomtesk.eap.DebugInfo;
import ru.ispras.telecomtesk.eap.TestIterator;
import ru.ispras.telecomtesk.eap.TestIteratorComlex;

public class IteratorRandomTLV
{
	static byte[] testAVPdata2 = {0x4,0x2e,0x11,(byte)0x95,0x6,0x25,0x44,(byte)0x8a,(byte)0xdd,0x7b,(byte)0xf6,(byte)0xac}; // 12 random bytes

	TestIterator itrAVPCode;
	TestIterator itrAVPFlag;
	TestIterator itrAVPLength;
	TestIterator itrAVPData;
	TestIteratorComlex itrAll;
	boolean endFlag;
	
	EAPtypePldPEAPtlv avpPld;
   
	IteratorRandomTLV() {
		itrAVPCode = new TestIterator();
		itrAVPFlag = new TestIterator();
		itrAVPLength = new TestIterator();
		itrAVPData = new TestIterator();
		TestIterator[] itrArray = {itrAVPData,itrAVPLength,itrAVPFlag,itrAVPCode};
		itrAll = new TestIteratorComlex(itrArray);
		endFlag = false;
	}
	
    public boolean isEnd() {
    	return this.endFlag;
    }

    public void printIteratorIndexes() {
		DebugInfo.printMessage(1,"itrAVPData itrAVPLength itrAVPFlag itrAVPCode " + itrAVPData.index + " " + itrAVPLength.index + " " + itrAVPFlag.index + " " + itrAVPCode.index);
    }
    
    public byte[] createRndAVP() {
		printIteratorIndexes();
		avpPld = new EAPtypePldPEAPtlv(0);

		setAddAVPCode(avpPld,itrAVPCode);
		setAddAVPFlag(avpPld,itrAVPFlag);
		setAddAVPLength(avpPld,itrAVPLength);
		setAddAVPData(avpPld,itrAVPData);
		if(!itrAll.next()) this.endFlag = true;
		
		avpPld.toByteArray();
		return avpPld.net_msg;
	}

	public void setAddAVPCode(EAPtypePldPEAPtlv pld, TestIterator itr) {
		switch(itr.index) {
		case 1: pld.tlvType = 0; break; 
		case 2: pld.tlvType = 1; break; 
		case 3: pld.tlvType = 2; break; 
		case 4: pld.tlvType = 79; break; 
		case 5: pld.tlvType = 255; break; 
		case 6: pld.tlvType = Integer.MAX_VALUE; itr.end(); break; 
		default: itr.end(); break; 
		}
	}
	public void setAddAVPFlag(EAPtypePldPEAPtlv pld, TestIterator itr) {
		switch(itr.index) {
		case 1: pld.flag = 0; break; // set M bit: |M R ...|
		case 2: pld.setTlvMBit(); itr.end(); break; // clear flag
		default: itr.end(); break; 
		}
	}
	public void setAddAVPLength(EAPtypePldPEAPtlv pld, TestIterator itr) {
		switch(itr.index) {
		case 1: break; 
		case 2: pld.setLength(0); break; 
		case 3: pld.setLength(3); break; 
		case 4: pld.setLength(5); break; 
		case 5: if(pld.value != null) pld.setLength(pld.value.length - 3); 
				break; 
		case 6: if(pld.value != null) pld.setLength(pld.value.length + 3);
				itr.end(); break;
		default: itr.end(); break; 
		}
	}
	public void setAddAVPData(EAPtypePldPEAPtlv pld, TestIterator itr) {
		switch(itr.index) {
		case 1: break; // no Data field
		case 2: pld.value = testAVPdata2; itr.end(); break; 
		default: itr.end(); break; 
		}
	}
}
