package ru.ispras.telecomtesk.eap.EAPSIM.Attributes;

import ru.ispras.telecomtesk.eap.ConvertTypes;
import ru.ispras.telecomtesk.eap.DebugInfo;
import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttribute;
import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttrType;


public class EAPsimAttrCounter extends EAPsimAttribute {

    public short counter = 1; // default value
	protected boolean isReservedField = false;

	public EAPsimAttrCounter(short cnt) {
		this.attrType = EAPsimAttrType.EAPSIM_AT_COUNTER.getValue();
		this.counter = cnt;
		this.value = ConvertTypes.hton(cnt);
		isValueSet = true;
		setLength(1);
	}

	public EAPsimAttrCounter(int cnt) {
		this((short)cnt);
	}

	// parse message constructor 
	public EAPsimAttrCounter(byte[] data, int len, int pos) {
		this.attrType = EAPsimAttrType.EAPSIM_AT_COUNTER.getValue();
		parseData(data, len, pos);
		if(this.value != null) {
			if(this.value.length == 2) {
				this.counter = ConvertTypes.ntohs(this.value,0);
			} else {
				DebugInfo.printMessage(1,"===Error! EAPsimAttrCounter: bad counter length");
				DebugInfo.printDump(1,this.value, "  counter:");
			}
		} else
			DebugInfo.printMessage(1,"===Error! EAPsimAttrCounter: counter value not found");
	}
}    
