package ru.ispras.telecomtesk.eap.EAPSIM.Attributes;

import ru.ispras.telecomtesk.eap.ConvertTypes;
import ru.ispras.telecomtesk.eap.DebugInfo;
import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttribute;
import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttrType;


public class EAPsimAttrSelectedVersion extends EAPsimAttribute {
    public short version = 1; // default value
	protected boolean isReservedField = false;

	public EAPsimAttrSelectedVersion(short ver) {
		this.attrType = EAPsimAttrType.EAPSIM_AT_SELECTED_VERSION.getValue();
		this.version = ver;
		this.value = ConvertTypes.hton(ver);
		isValueSet = true;
		setLength(1);
	}

	public EAPsimAttrSelectedVersion(int ver) {
		this((short)ver);
	}

	// parse message constructor 
	public EAPsimAttrSelectedVersion(byte[] data, int len, int pos) {
		this.attrType = EAPsimAttrType.EAPSIM_AT_SELECTED_VERSION.getValue();
		parseData(data, len, pos);
		if(this.value != null) {
			if(this.value.length == 2) {
				this.version = ConvertTypes.ntohs(this.value,0);
			} else {
				DebugInfo.printMessage(1,"===Error! EAPsimAttrSelectedVersion: bad Version length");
				DebugInfo.printDump(1,this.value, "  version:");
			}
		} else
			DebugInfo.printMessage(1,"===Error! EAPsimAttrSelectedVersion: Version value not found");
	}

	public int checkValue(short[] verList) {
		int res = 2;
		if(verList != null) {
			for (int j = 0; j < verList.length; j++) {
				if(version == verList[j]) {
					DebugInfo.printMessage(1,"EAPsimAttribute::checkValue: valid version number");
					res = 0; break;
				}
			}
		} else {
			DebugInfo.printMessage(1,"===Warning! EAPsimAttribute::checkValue: no input data");
			res = 1;
		}
		return res;
	}
}    
