package ru.ispras.telecomtesk.eap.EAPSIM;

public enum EAPsimAttrType { 
	EAPSIM_AT_UNKNOWN(0),
	EAPSIM_AT_RAND(1),
	EAPSIM_AT_AUTN(2),
	EAPSIM_AT_RES(3),
	EAPSIM_AT_AUTS(4),
	EAPSIM_AT_PADDING(6),
	EAPSIM_AT_NONCE_MT(7),
	EAPSIM_AT_PERMANENT_ID_REQ(10),
	EAPSIM_AT_MAC(11),
	EAPSIM_AT_NOTIFICATION(12),
	EAPSIM_AT_ANY_ID_REQ(13),
	EAPSIM_AT_IDENTITY(14),
	EAPSIM_AT_VERSION_LIST(15),
	EAPSIM_AT_SELECTED_VERSION(16),
	EAPSIM_AT_FULLAUTH_ID_REQ(17),
	EAPSIM_AT_COUNTER(19),
	EAPSIM_AT_COUNTER_TOO_SMALL(20),
	EAPSIM_AT_NONCE_S(21),
	EAPSIM_AT_CLIENT_ERROR_CODE(22),
	EAPSIM_AT_IV(129),
	EAPSIM_AT_ENCR_DATA(130),
	EAPSIM_AT_NEXT_PSEUDONYM(132),
	EAPSIM_AT_NEXT_REAUTH_ID(133),
	EAPSIM_AT_CHECKCODE(134),
	EAPSIM_AT_RESULT_IND(135),
	EAPSIM_AT_EXPERIMENTAL(255);
	
	public int type;
	
	private EAPsimAttrType(int type) {
		this.type = type;
	}
	
	public int getValue() {
		return type;
	}

	public static String getString(int tp) {
		return "" + tp + ": " + valueOf(tp);
	}

	public static EAPsimAttrType valueOf(int tp) {
		switch (tp) {
		case 0:	return EAPSIM_AT_UNKNOWN;
		case 1: return EAPSIM_AT_RAND;
		case 2: return EAPSIM_AT_AUTN;
		case 3: return EAPSIM_AT_RES;
		case 4: return EAPSIM_AT_AUTS;
		case 6: return EAPSIM_AT_PADDING;
		case 7: return EAPSIM_AT_NONCE_MT;
		case 10: return EAPSIM_AT_PERMANENT_ID_REQ;
		case 11: return EAPSIM_AT_MAC;
		case 12: return EAPSIM_AT_NOTIFICATION;
		case 13: return EAPSIM_AT_ANY_ID_REQ;
		case 14: return EAPSIM_AT_IDENTITY;
		case 15: return EAPSIM_AT_VERSION_LIST;
		case 16: return EAPSIM_AT_SELECTED_VERSION;
		case 17: return EAPSIM_AT_FULLAUTH_ID_REQ;
		case 19: return EAPSIM_AT_COUNTER;
		case 20: return EAPSIM_AT_COUNTER_TOO_SMALL;
		case 21: return EAPSIM_AT_NONCE_S;
		case 22: return EAPSIM_AT_CLIENT_ERROR_CODE;
		case 129: return EAPSIM_AT_IV;
		case 130: return EAPSIM_AT_ENCR_DATA;
		case 132: return EAPSIM_AT_NEXT_PSEUDONYM;
		case 133: return EAPSIM_AT_NEXT_REAUTH_ID;
		case 134: return EAPSIM_AT_CHECKCODE;
		case 135: return EAPSIM_AT_RESULT_IND;
		default: return EAPSIM_AT_EXPERIMENTAL;
		}
	}
}