package ru.ispras.telecomtesk.eap.EAPSIM;

import ru.ispras.telecomtesk.eap.DebugInfo;

import java.util.ArrayList;


public class EAPsimTriplets {    
	public ArrayList<EAPsimGSMtriplet> tripletList = null; 

	public EAPsimTriplets() {
		tripletList = new ArrayList<EAPsimGSMtriplet>();
	}

	public void addTriplet(EAPsimGSMtriplet trpl) {
		if(tripletList == null)
			tripletList = new ArrayList<EAPsimGSMtriplet>();
		if(trpl != null)
			tripletList.add(trpl);
	}

	public EAPsimGSMtriplet getTriplet(int index) {
		EAPsimGSMtriplet trpl = null;
		try {
			trpl = tripletList.get(index);
		}
		catch (Exception ignored) {}
		
		return trpl;
	}
	
	public EAPsimGSMtriplet getTripletByRand(byte[] rnd) {
		EAPsimGSMtriplet trpl = null;
		try {
			if(tripletList != null)
				for(int i = 0; i<tripletList.size(); i++) {
					if(tripletList.get(i).compareRand(rnd) == true) {
						trpl = tripletList.get(i);
						break;
					}
				}
		}
		catch (Exception ignored) {
    			DebugInfo.printMessage(1,"EAPsimTriplets::getTripletByRand error");
		}
		
		return trpl;
	}
	
	public EAPsimTriplets getTripletByRand(byte[][] randList) {
		EAPsimTriplets trplList = null;
		EAPsimGSMtriplet trpl = null;

		if((randList != null) && (tripletList != null)) {
			trplList = new EAPsimTriplets();

			for(int i=0; i < randList.length; i++) {
				if((randList[i] != null) && ((trpl = getTripletByRand(randList[i])) != null)) {
	                	   trplList.addTriplet(trpl);
				}
                        }
		} else {
    			DebugInfo.printMessage(1,"EAPsimTriplets::getTripletByRand: null pointer");

		}
		
		return trplList;
	}
	
	public byte[] combineAllKc() {
		byte[] nKc = null;
        	int len, pos, i;
                EAPsimGSMtriplet trpl;

		if(tripletList != null) {
        		for(i=0,len=0; i < tripletList.size(); i++) {
				trpl = tripletList.get(i);
				if((trpl != null) && (trpl.kc != null))
                			len += trpl.kc.length;
        		}
        		nKc = new byte[len];
       			for(i=0,pos=0; i < tripletList.size(); i++) {
				trpl = tripletList.get(i);
				if((trpl != null) && (trpl.kc != null)) {
                			System.arraycopy(trpl.kc, 0, nKc, pos, trpl.kc.length);
                			pos += trpl.kc.length;
				}
        		}
		}
		return nKc;
	}
	
	public byte[] combineAllSres() {
		byte[] nSres = null;
        	int len, pos, i;
                EAPsimGSMtriplet trpl;

		if(tripletList != null) {
        		for(i=0,len=0; i < tripletList.size(); i++) {
				trpl = tripletList.get(i);
				if((trpl != null) && (trpl.sres != null))
                			len += trpl.sres.length;
        		}
        		nSres = new byte[len];
       			for(i=0,pos=0; i < tripletList.size(); i++) {
				trpl = tripletList.get(i);
				if((trpl != null) && (trpl.sres != null)) {
                			System.arraycopy(trpl.sres, 0, nSres, pos, trpl.sres.length);
                			pos += trpl.sres.length;
				}
        		}
		}
		return nSres;
	}
	
	public void clearTripletList() {
		if(tripletList != null)
			tripletList.clear();
	}
	
}
