package ru.ispras.telecomtesk.eap.EAPTTLSv0;

public enum EAPtypePldTtlsv0AVPCode { 
	TTLS_AVPCODE_UNKNOWN(0),
	TTLS_AVPCODE_USER_NAME(1),
	TTLS_AVPCODE_USER_PASSWORD(2),
	TTLS_AVPCODE_REPLY_MESSAGE(18),
	TTLS_AVPCODE_STATE(24),
	TTLS_AVPCODE_VENDOR_SPECIFIC(26),
	TTLS_AVPCODE_SESSION_TIMEOUT(27),
	TTLS_AVPCODE_EAP_MESSAGE(79),
	TTLS_AVPCODE_MESSAGE_AUTHENTICATOR(80),
	TTLS_AVPCODE_RESERVED(255);   
	
	public int type;
	
	private EAPtypePldTtlsv0AVPCode(int type) {
		this.type = type;
	}
	
	public int getValue() {
		return type;
	}
	
	public static EAPtypePldTtlsv0AVPCode valueOf(int tp) {
		switch (tp) {
		case 1: return TTLS_AVPCODE_USER_NAME;
		case 2: return TTLS_AVPCODE_USER_PASSWORD;
		case 18: return TTLS_AVPCODE_REPLY_MESSAGE;
		case 24: return TTLS_AVPCODE_STATE;
		case 26: return TTLS_AVPCODE_VENDOR_SPECIFIC;
		case 27: return TTLS_AVPCODE_SESSION_TIMEOUT;
		case 79: return TTLS_AVPCODE_EAP_MESSAGE;
		case 80: return TTLS_AVPCODE_MESSAGE_AUTHENTICATOR;
		default: return TTLS_AVPCODE_UNKNOWN;
		}
	}

}