package ru.ispras.telecomtesk.eap.EAPTTLSv0;

import ru.ispras.telecomtesk.eap.DebugInfo;
import ru.ispras.telecomtesk.eap.TestIterator;
import ru.ispras.telecomtesk.eap.TestIteratorComlex;

public class IteratorRandomAVP
{
	TestIterator itrAVPCode;
	TestIterator itrAVPFlag;
	TestIterator itrAVPLength;
	TestIterator itrAVPVendor;
	TestIterator itrAVPData;
	TestIteratorComlex itrAll;
	boolean endFlag;
	
	EAPtypePldTtlsv0AVP avpPld;
   
	IteratorRandomAVP() {
		itrAVPCode = new TestIterator();
		itrAVPFlag = new TestIterator();
		itrAVPLength = new TestIterator();
		itrAVPVendor = new TestIterator();
		itrAVPData = new TestIterator();
		TestIterator[] itrArray = {itrAVPData,itrAVPVendor,itrAVPLength,itrAVPFlag,itrAVPCode};
		itrAll = new TestIteratorComlex(itrArray);
		endFlag = false;
	}
	
    public boolean isEnd() {
    	return this.endFlag;
    }

    public void printIteratorIndexes() {
		DebugInfo.printMessage(1,"itrAVPData itrAVPVendor itrAVPLength itrAVPFlag itrAVPCode " + itrAVPData.index + " "  + itrAVPVendor.index + " " + itrAVPLength.index + " " + itrAVPFlag.index + " " + itrAVPCode.index);
    }
    
    public byte[] createRndAVP() {
		printIteratorIndexes();
		avpPld = new EAPtypePldTtlsv0AVP(0);

		setAddAVPData(avpPld,itrAVPData);
		setAddAVPVendor(avpPld,itrAVPVendor);
		setAddAVPFlag(avpPld,itrAVPFlag);
		setAddAVPLength(avpPld,itrAVPLength);
		setAddAVPCode(avpPld,itrAVPCode);
		if(!itrAll.next()) this.endFlag = true;
		
		avpPld.toByteArray();
		return avpPld.net_msg;
	}

	public void setAddAVPCode(EAPtypePldTtlsv0AVP pld, TestIterator itr) {
		switch(itr.index) {
		case 1: pld.avpCode = 0; break; 
		case 2: pld.avpCode = 1; break; 
		case 3: pld.avpCode = 18; break; 
		case 4: pld.avpCode = 26; break; 
		case 5: pld.avpCode = 79; break; 
		case 6: pld.avpCode = 255; break; 
		case 7: pld.avpCode = Integer.MAX_VALUE; itr.end(); break; 
		default: itr.end(); break; 
		}
	}
	public void setAddAVPFlag(EAPtypePldTtlsv0AVP pld, TestIterator itr) {
		switch(itr.index) {
		case 1: pld.setAvpFlag(false,true); break; // set M bit: |V M r r r r r r|
		case 2: pld.setAvpFlag(false,false); itr.end(); break; // clear flag
		default: itr.end(); break; 
		}
	}
	public void setAddAVPLength(EAPtypePldTtlsv0AVP pld, TestIterator itr) {
		switch(itr.index) {
		case 1: break; 
		case 2: pld.setLength(0); break; 
		case 3: pld.setLength(3); break; 
		case 4: pld.setLength(5); break; 
		case 5: if(pld.value != null) {
					pld.setLength(); pld.setLength(pld.length - 5); 
				}
				break; 
		case 6: if(pld.value != null) {
					pld.setLength(); pld.setLength(pld.length + 3); 
				}
				itr.end(); break;
		default: itr.end(); break; 
		}
	}
	public void setAddAVPVendor(EAPtypePldTtlsv0AVP pld, TestIterator itr) {
		switch(itr.index) {
		case 1: break; // no Vendor field
		case 2: pld.vendorID = 0; pld.setAvpVBit(); break; 
		case 3: pld.vendorID = 777; pld.setAvpVBit(); itr.end(); break; 
		default: itr.end(); break; 
		}
	}
	public void setAddAVPData(EAPtypePldTtlsv0AVP pld, TestIterator itr) {
		switch(itr.index) {
		case 1: break; // no Data field
		case 2: pld.value = TestTTlsv0TLSSequence2.testAVPdata2; itr.end(); break; 
		default: itr.end(); break; 
		}
	}
}
