//
// After EAP-TLS-Handshake finished send: 
//   AVP-EAP-Identity + AVP-EAP-Test
//

package ru.ispras.telecomtesk.eap.EAPTTLSv0;

import java.util.ArrayList;

import ru.ispras.telecomtesk.tlsv12.Tlsv12Client;
import ru.ispras.telecomtesk.tlsv12.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv12.TLSSocket.TLSResponse;

import ru.ispras.telecomtesk.eap.*;
import ru.ispras.telecomtesk.eap.EAPTLS.EAPTlsFragmentation;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;





public class testEAPTtlsv0_tls_3
{
    public static void main(String args[]) throws Exception {
    	testEAPTtlsv0_tls_3_Run test1 = new testEAPTtlsv0_tls_3_Run();
    	test1.runtest();
    }
}

class testEAPTtlsv0_tls_3_Run
{
	public static byte[] remoteHostRaw = {(byte)(10),(byte)(10),(byte)(12),(byte)(12)};
	public static byte[] localHostRaw = {(byte)(10),(byte)(10),(byte)(9),(byte)(53)};

	EAPtype testType = EAPtype.EAP_TYPE_TTLSv0;

	String SharedSecretStr = "testing123";
//	String SharedSecretStr = "secret";
	String userNameStr = "tester";
	String UserPwdStr = "tester"; // "123456";
//	String UserPwdStr = "efqcltpm+>y]";

	RecordLayer tlsmsg = null;
	int tlsFullMsgLen = 0;
	ArrayList<byte[]> tlsMsgList = null;
	EAPRadiusSocket sock = null;
	int eapReject = 0, counterSeq = 0, eapNoAnsw = 0;
	boolean tstEap = false;

	Tlsv12Client tlsClnt;
	TestTTlsv0TLSSequence3 testSeq1;
	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 3;
		DebugInfo.maxDumpSize = 300;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 3;

		sock = new EAPRadiusSocket(SharedSecretStr, userNameStr, remoteHostRaw); 
//		sock.setSocketTimeout(5000);
		tlsMsgList = new ArrayList<byte[]>();
		testSeq1 = new TestTTlsv0TLSSequence3(userNameStr);
		tlsClnt = new Tlsv12Client();

		int res;
	    do {
			testSeq1.printrndAVPIteratorIndexes();
			DebugInfo.printMessage(1,"number of tests " + counterSeq);
			DebugInfo.printMessage(1,"rejected EAP Packets " + eapReject);
    		res = sendPacketsSequence(1); // order of AVP-EAP-Identity and AVP-EAP-Test
			sock.sendTerminatePacket();
			counterSeq++;
	    } while(!testSeq1.isEnd());
	    testSeq1.clear();
	    do {
			testSeq1.printrndAVPIteratorIndexes();
			DebugInfo.printMessage(1,"number of tests " + counterSeq);
			DebugInfo.printMessage(1,"rejected EAP Packets " + eapReject);
    		res = sendPacketsSequence(2); // order of AVP-EAP-Test and AVP-EAP-Identity
			sock.sendTerminatePacket();
			counterSeq++;
	    } while(!testSeq1.isEnd());
		DebugInfo.printMessage(1,"run: counterEAPPackets " + sock.counterEAPPackets + ", counterEAPTerminatePackets " + sock.counterEAPTerminatePackets);
		DebugInfo.printMessage(1,"number of tests " + counterSeq);
		DebugInfo.printMessage(1,"rejected EAP Packets " + eapReject);

// close socket		
		sock.closeSocket();
	}

	
	int sendPacketsSequence(int order) {
		int res = 0;
		
		// send init ID packet
		DebugInfo.printMessage(1,"\n================================================");
		
		res = sock.sendInitEAPpacket();
		if((res != 0) || (!sock.receivedData)) { 
			DebugInfo.printMessage(1,"!!! sendInitEAPpacket failed");
			return 1;
		}
		
		// send second message		
		DebugInfo.printMessageWithSeparator(1,"create TLS ClientHello");
		byte[] tlsClHello = tlsClnt.createClientFirstTlsMsg();
		if(tlsClHello == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client Hello failed");
			return 2;
		}
		EAPpldBasic ttlsEapPktCH = createEapPkt(new EAPtypePldTtlsv0(tlsClHello));
		if(0 != recvAndParseEAPmsg(ttlsEapPktCH)) return 3;

    	// send third message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt3");
		byte[] msgSF = tlsClnt.createClientSecondTlsFlow();
		if(msgSF == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client second flow failed");
			return 4;
		}
		EAPpldBasic ttlsEapPktThird = createEapPkt(new EAPtypePldTtlsv0(msgSF));
		if(0 != recvAndParseEAPmsg(ttlsEapPktThird)) return 5;
    	
	   	// send fourth message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt4 under TLS");
		byte[] testAVPdata = testSeq1.setTestPld(order);
		DebugInfo.printMessage(1,"^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^");
		DebugInfo.printDump(1, testAVPdata, "TEST AVP");
		byte[] tlsAppl = tlsClnt.createApplicationData(testAVPdata);
		EAPpldBasic ttlsEapPktApp = createEapPkt(new EAPtypePldTtlsv0(tlsAppl));
		DebugInfo.printMessage(1,"**********************************************************");
		int eapReject = 0;
		tstEap = true;
		if(0 != recvAndParseEAPmsg(ttlsEapPktApp)) return 7;
		tstEap = false;

		return res;
	}

	EAPpldBasic createEapPkt(EAPtypePldTtlsv0 ttlspld) {
		EAPpldBasic testEapPkt = new EAPpldBasic();
		testEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		testEapPkt.identifier = sock.getReceivedEAPPacket().identifier;
		testEapPkt.type = testType;
		testEapPkt.EAPmethodPld = ttlspld;
		testEapPkt.isLengthSet = false;
		testEapPkt.toByteArray();
		return testEapPkt;
	}


	int recvFullEAPmsg() {
		int res = 0;
		tlsMsgList.clear();
		boolean cicleFlag;
		EAPheader recvEAP;
		tlsFullMsgLen = 0;
		cicleFlag = true;
		int counterEmptyRecv = 0;
		EAPpldBasic ttlsEapACKpkt = new EAPpldBasic();
		
		ttlsEapACKpkt.code = EAPcode.EAP_CODE_RESPONSE;
		ttlsEapACKpkt.type = testType;

		while(cicleFlag) {
			res = sock.sendEAPpacket();
			if((res != 0) || (!sock.receivedData)) { 
				DebugInfo.printMessage(1,"!!! sendEAPpacket failed");
				return 1;
			}
			recvEAP = sock.getReceivedEAPPacket();
			if(tstEap) {
				if(!sock.receivedData)
					eapNoAnsw ++;
				if(recvEAP.code == EAPcode.EAP_CODE_FAILURE)
					eapReject ++;
			}
			cicleFlag = false;

			if(recvEAP instanceof EAPpldBasic) {
				if(((EAPpldBasic) recvEAP).type == testType) {
					EAPtypePldTtlsv0 curpld = (EAPtypePldTtlsv0)((EAPpldBasic)recvEAP).EAPmethodPld;
					if(curpld.getEapTlsLBit()) {
						if(tlsFullMsgLen == 0)
							tlsFullMsgLen = curpld.tlsMessageLenght;
						else {
							DebugInfo.printMessage(1,"!!! Warning! tlsMessageLenght dublicate");
						}
					}
					tlsMsgList.add(curpld.tlsData);
					if(curpld.getEapTlsMBit()) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = sock.getReceivedEAPPacket().identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldTtlsv0();
						ttlsEapACKpkt.isLengthSet = false;
						ttlsEapACKpkt.toByteArray();
						sock.setEapMessage(ttlsEapACKpkt);
					} else if((curpld.tlsData == null) || (curpld.tlsData.length == 0)) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = sock.getReceivedEAPPacket().identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldTtlsv0();
						ttlsEapACKpkt.isLengthSet = false;
						if(counterEmptyRecv > 0)
							((EAPtypePldTtlsv0)(ttlsEapACKpkt.EAPmethodPld)).setEapTlsFlag(true,false,false);
						ttlsEapACKpkt.toByteArray();
						sock.setEapMessage(ttlsEapACKpkt);
						counterEmptyRecv++;
					}
				}
			}
		}
		return res;
	}

	
	int parseTLSresp(byte[] tlsmsg) {
		DebugInfo.printMessageWithSeparator(1,"parse tls response");
		int res = 0;
		
		TLSResponse resp = new TLSResponse(tlsmsg);
   		resp.printResponse();
    	if(resp.err != 0) {
			DebugInfo.printMessage(1,"!!! TLSResponse return error");
			res = 1;
    	} else {
    		try {
    			ArrayList<RecordLayer> tlsResp = tlsClnt.parseTlsResponse(resp);	
    			if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
    				DebugInfo.printMessage(1,"!!! TLSResponse return error");
    				tlsClnt.conSpec.disconnect();
    				res = 2;
    			}
    		} catch (Exception err) {
    			DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
    			res = 3;
    		}
    	}
    	return res;
	}

	int recvAndParseEAPmsg(EAPpldBasic ttlsEapPkt) {
		int res = 0;
		
		sock.setEapMessage(ttlsEapPkt);

		if(0 != recvFullEAPmsg()) return 1;

		byte[] tlsRaw = EAPTlsFragmentation.combineTlsMessages(tlsMsgList);
		if(tlsRaw == null) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw Null pointer");
		} else if(tlsRaw.length != tlsFullMsgLen) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw length failed: " + tlsRaw.length + " must " + tlsFullMsgLen);
		} else {
			DebugInfo.printDumpWithLength(2, tlsRaw, "Get full tls messages");
		}

		// parse tls response		
		if(0 != parseTLSresp(tlsRaw)) return 2;

		return res;
	}

}




class TestTTlsv0TLSSequence3
{
	static byte[] testAVPdata1 = {0,0,0,0,0,0,0,0,0,0,0,0}; // 12 zero bytes
	static byte[] testAVPdata2 = {0x4,0x2e,0x11,(byte)0x95,0x6,0x25,0x44,(byte)0x8a,(byte)0xdd,0x7b,(byte)0xf6,(byte)0xac}; // 12 random bytes

	static byte[] avpEAPIdraw;
	
	EAPpldBasic eapInitMsg;
	EAPtypePldTtlsv0AVP avpEAPId;

	TestIterator itrEapAVP;
	TestIterator itrBytesAVP;
	IteratorRandomAVP rndAVP;
	TestIterator itrMain;

   
	TestTTlsv0TLSSequence3(String userName) {
		eapInitMsg = new EAPpldResponse(70, EAPtype.EAP_TYPE_IDENTITY);
	    eapInitMsg.EAPmethodPld = new EAPtypePldID(userName.getBytes());
	    eapInitMsg.toByteArray();
		avpEAPId = new EAPtypePldTtlsv0AVP(EAPtypePldTtlsv0AVPCode.TTLS_AVPCODE_EAP_MESSAGE.getValue(),
				eapInitMsg.net_msg);
		avpEAPId.toByteArray();
		avpEAPIdraw = new byte[avpEAPId.net_msg.length];
		System.arraycopy(avpEAPId.net_msg, 0, avpEAPIdraw, 0, avpEAPIdraw.length);
		rndAVP = new IteratorRandomAVP();
		itrEapAVP = new TestIterator();
		itrBytesAVP = new TestIterator();
		itrMain = new TestIterator();
	}
	
    public boolean isEnd() {
    	return itrMain.isEnd();
    }

    public void printrndAVPIteratorIndexes() {
    	rndAVP.printIteratorIndexes();
    }
    
    public void clear() {
		rndAVP = new IteratorRandomAVP();
		itrEapAVP.clear();
		itrBytesAVP.clear();
		itrMain.clear();
    }

    public byte[] setTestPld(int order) {
		DebugInfo.printMessage(1,"setTestAVP");
		DebugInfo.printMessage(1,"itrMain itrEapAVP itrBytesAVP " + itrMain.index + " "  + itrEapAVP.index + " " + itrBytesAVP.index);
		DebugInfo.printMessage(1,"itrMain itrEapAVP itrBytesAVP " + itrMain.isEnd() + " "  + itrEapAVP.isEnd() + " " + itrBytesAVP.isEnd());
		byte[] avpData = null;
		byte[] avpTestData = null;


		switch(itrMain.index) {
		case 1: avpTestData = setEapAVP(itrEapAVP); 
				if(!itrEapAVP.next()) itrMain.next(); 
				break;
		case 2: avpTestData = setRandomBytesAVP(itrBytesAVP); 
				if(!itrBytesAVP.next()) itrMain.next(); 
				break;
		case 3: avpTestData = rndAVP.createRndAVP(); 
				if(rndAVP.isEnd()) {itrMain.next(); itrMain.end();} 
				break;
		}
		
		if((avpTestData != null)&&(avpTestData.length != 0)) {
			avpData = new byte[avpEAPIdraw.length + avpTestData.length];
			if(order == 1) {
				System.arraycopy(avpEAPIdraw, 0, avpData, 0, avpEAPIdraw.length);
				System.arraycopy(avpTestData, 0, avpData, avpEAPIdraw.length, avpTestData.length);
			} else {
				System.arraycopy(avpTestData, 0, avpData, 0, avpTestData.length);
				System.arraycopy(avpEAPIdraw, 0, avpData, avpTestData.length, avpEAPIdraw.length);
			}
		} else {
			avpData = avpEAPIdraw;
		}
		
		DebugInfo.printMessage(1,"setTestPld return");
		return avpData;
	}
	
	public byte[] setEapAVP(TestIterator itr) {
		avpEAPId.isLengthSet = false;
		avpEAPId.flag = 0;
		switch(itr.index) {
		case 1: avpEAPId.setAvpFlag(false,true); break; // set M bit: |V M r r r r r r|
		case 2: break; // clear M bit
		case 3: avpEAPId.flag = 63; break; // set R bits: |V M r r r r r r|
		case 4: avpEAPId.setLength(0); break; 
		case 5: avpEAPId.setLength(); avpEAPId.setLength(avpEAPId.length - 3); break; 
		case 6: avpEAPId.setLength(); avpEAPId.setLength(avpEAPId.length + 3); break; 
		case 7: avpEAPId.vendorID = 0; avpEAPId.setAvpVBit(); itr.end(); break; 
		}
		avpEAPId.toByteArray();
		return avpEAPId.net_msg;
	}

	public byte[] setRandomBytesAVP(TestIterator itr) {
		switch(itr.index) {
		case 1: return testAVPdata1; 
		case 2: itr.end(); return testAVPdata2;
		default: itr.end(); return null;
		}
	}
}


