//
//  EAP-TLS-MD5 full exchange: 
//

package ru.ispras.telecomtesk.eap.EAPTTLSv0;

import java.util.ArrayList;

import ru.ispras.telecomtesk.tlsv12.Tlsv12Client;
import ru.ispras.telecomtesk.tlsv12.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv12.TLSSocket.TLSResponse;

import ru.ispras.telecomtesk.eap.*;
import ru.ispras.telecomtesk.eap.EAPTLS.EAPTlsFragmentation;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;





public class tryEAPTtlsv0_tls
{
    public static void main(String args[]) throws Exception {
    	tryEAPTtlsv0_tls_Run test1 = new tryEAPTtlsv0_tls_Run();
    	test1.runtest();
    }
}

class tryEAPTtlsv0_tls_Run
{
	public static byte[] remoteHostRaw = {(byte)(10),(byte)(10),(byte)(12),(byte)(12)};
	public static byte[] localHostRaw = {(byte)(10),(byte)(10),(byte)(9),(byte)(53)};

	EAPtype testType = EAPtype.EAP_TYPE_TTLSv0;

	String SharedSecretStr = "testing123";
//	String SharedSecretStr = "secret";
	String userNameStr = "tester";
	String UserPwdStr = "tester"; // "123456";
//	String UserPwdStr = "efqcltpm+>y]";

	RecordLayer tlsmsg = null;
	int tlsFullMsgLen = 0;
	ArrayList<byte[]> tlsMsgList = null;
	EAPRadiusSocket sock = null;
	int eapTestInd = 0, eapSubInd = 0;

	Tlsv12Client tlsClnt;
	
	ArrayList<RecordLayer> tlsResp;
	
	public void runtest() throws Exception {
		DebugInfo.maxDumpSize = 200;
		DebugInfo.debugLevel = 3;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 3;

		sock = new EAPRadiusSocket(SharedSecretStr, userNameStr, remoteHostRaw); 
//		sock.setSocketTimeout(5000);
		tlsMsgList = new ArrayList<byte[]>();
		tlsClnt = new Tlsv12Client();

   		sendPacketsSequence();
		sock.sendTerminatePacket();
		DebugInfo.printMessage(1,"run: counterEAPPackets " + sock.counterEAPPackets + ", counterEAPTerminatePackets " + sock.counterEAPTerminatePackets);

// close socket		
		sock.closeSocket();
	}

	
	int sendPacketsSequence() {
		int res = 0;
		
		// send init ID packet
		DebugInfo.printMessage(1,"\n================================================");
		
		res = sock.sendInitEAPpacket();
		if((res != 0) || (!sock.receivedData)) { 
			DebugInfo.printMessage(1,"!!! sendInitEAPpacket failed");
			return 1;
		}
		
		// send second message		
		DebugInfo.printMessageWithSeparator(1,"create TLS ClientHello");
		byte[] tlsClHello = tlsClnt.createClientFirstTlsMsg();
		if(tlsClHello == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client Hello failed");
			return 2;
		}
		EAPpldBasic ttlsEapPktCH = createEapPkt(new EAPtypePldTtlsv0(tlsClHello));
		if(0 != recvAndParseEAPmsg(ttlsEapPktCH)) return 3;

    	// send third message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt3");
		byte[] msgSF = tlsClnt.createClientSecondTlsFlow();
		if(msgSF == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client second flow failed");
			return 4;
		}
		EAPpldBasic ttlsEapPktThird = createEapPkt(new EAPtypePldTtlsv0(msgSF));
		if(0 != recvAndParseEAPmsg(ttlsEapPktThird)) return 5;

		// TLS Handshake complete

	   	// send fourth message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt4 under TLS");
		DebugInfo.maxDumpSize = 400;
		DebugInfo.debugLevel = 6;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 6;
		EAPpldBasic eapInitMsg = new EAPpldResponse(70, EAPtype.EAP_TYPE_IDENTITY);
	    eapInitMsg.EAPmethodPld = new EAPtypePldID(userNameStr.getBytes());
	    eapInitMsg.toByteArray();
	    EAPtypePldTtlsv0AVP avpEAPId = new EAPtypePldTtlsv0AVP(EAPtypePldTtlsv0AVPCode.TTLS_AVPCODE_EAP_MESSAGE.getValue(),
				eapInitMsg.net_msg);
	    avpEAPId.toByteArray();
		byte[] tlsAppl = tlsClnt.createApplicationData(avpEAPId.net_msg);
		EAPpldBasic ttlsEapPktApp = createEapPkt(new EAPtypePldTtlsv0(tlsAppl));
		DebugInfo.printMessage(1,"**********************************************************");
		if(0 != recvAndParseEAPmsg(ttlsEapPktApp)) return 7;

	   	// send next message
		DebugInfo.printMessageWithSeparator(1,"get Tunneled EAP msg");
		EAPtypePldTtlsv0AVP avptun = new EAPtypePldTtlsv0AVP(0);
		avptun.net_msg = getTunneledEAPmsg();
		avptun.parseNetMessage();
		avptun.print();
		byte[] eaptun = avptun.value;
		EAPheader receivedEAPtunPkt = null;
		int res2;
		if(eaptun != null) {
			DebugInfo.printMessage(1,"EAP message try parse");
			if(eaptun.length > 4)
				receivedEAPtunPkt = new EAPpldBasic();
			else
				receivedEAPtunPkt = new EAPheader();
			
			receivedEAPtunPkt.net_msg = eaptun;
			res2 = receivedEAPtunPkt.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAPRadiusSocket::parseRecvMessage: EAP packet was parsed, res: " + res2);
			receivedEAPtunPkt.print("   ");
			if(res2 != 0) return 3;
		}

		DebugInfo.printMessageWithSeparator(1,"try create pkt5 under TLS");

		EAPpldBasic eapMsg2 = new EAPpldBasic();
        eapMsg2.code = EAPcode.EAP_CODE_RESPONSE;
        eapMsg2.identifier = receivedEAPtunPkt.identifier;
        eapMsg2.type = EAPtype.EAP_TYPE_MD5CHALLENGE;
        EAPtypePldMd5 eapPldMd5 = new EAPtypePldMd5();
   		try {
   	        eapPldMd5.setMD5value(eapMsg2.identifier, ((EAPtypePldMd5)(((EAPpldBasic)receivedEAPtunPkt).EAPmethodPld)).value, UserPwdStr.getBytes());
   		} catch (Exception err) {
   			DebugInfo.printMessage(1,"===Error! setMD5value Exception: " + err);
   		}
        eapMsg2.EAPmethodPld = eapPldMd5;
        eapMsg2.toByteArray();
	    EAPtypePldTtlsv0AVP avpEAP = new EAPtypePldTtlsv0AVP(EAPtypePldTtlsv0AVPCode.TTLS_AVPCODE_EAP_MESSAGE.getValue(),
	    		eapMsg2.net_msg);
	    avpEAP.toByteArray();
		tlsAppl = tlsClnt.createApplicationData(avpEAP.net_msg);
		EAPpldBasic ttlsEapPktApp2 = createEapPkt(new EAPtypePldTtlsv0(tlsAppl));
		DebugInfo.printMessage(1,"**********************************************************");

		DebugInfo.maxDumpSize = 200;
		DebugInfo.debugLevel = 3;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 3;
		if(0 != recvAndParseEAPmsg(ttlsEapPktApp2)) return 7;

		return res;
	}

	EAPpldBasic createEapPkt(EAPtypePldTtlsv0 ttlspld) {
		EAPpldBasic testEapPkt = new EAPpldBasic();
		testEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		testEapPkt.identifier = sock.getReceivedEAPPacket().identifier;
		testEapPkt.type = testType;
		testEapPkt.EAPmethodPld = ttlspld;
		testEapPkt.isLengthSet = false;
		testEapPkt.toByteArray();
		return testEapPkt;
	}


	int recvFullEAPmsg() {
		int res = 0;
		tlsMsgList.clear();
		boolean cicleFlag;
		EAPheader recvEAP;
		tlsFullMsgLen = 0;
		cicleFlag = true;
		int counterEmptyRecv = 0;
		EAPpldBasic ttlsEapACKpkt = new EAPpldBasic();
		
		ttlsEapACKpkt.code = EAPcode.EAP_CODE_RESPONSE;
		ttlsEapACKpkt.type = testType;

		while(cicleFlag) {
			res = sock.sendEAPpacket();
			if((res != 0) || (!sock.receivedData)) { 
				DebugInfo.printMessage(1,"!!! sendEAPpacket failed");
				return 1;
			}
			recvEAP = sock.getReceivedEAPPacket();
			cicleFlag = false;

			if(recvEAP instanceof EAPpldBasic) {
				if(((EAPpldBasic) recvEAP).type == testType) {
					EAPtypePldTtlsv0 curpld = (EAPtypePldTtlsv0)((EAPpldBasic)recvEAP).EAPmethodPld;
					if(curpld.getEapTlsLBit()) {
						if(tlsFullMsgLen == 0)
							tlsFullMsgLen = curpld.tlsMessageLenght;
						else {
							DebugInfo.printMessage(1,"!!! Warning! tlsMessageLenght dublicate");
						}
					}
					tlsMsgList.add(curpld.tlsData);
					if(curpld.getEapTlsMBit()) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = sock.getReceivedEAPPacket().identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldTtlsv0();
						ttlsEapACKpkt.isLengthSet = false;
						ttlsEapACKpkt.toByteArray();
						sock.setEapMessage(ttlsEapACKpkt);
					} else if((curpld.tlsData == null) || (curpld.tlsData.length == 0)) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = sock.getReceivedEAPPacket().identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldTtlsv0();
						ttlsEapACKpkt.isLengthSet = false;
						if(counterEmptyRecv > 0)
							((EAPtypePldTtlsv0)(ttlsEapACKpkt.EAPmethodPld)).setEapTlsFlag(true,false,false);
						ttlsEapACKpkt.toByteArray();
						sock.setEapMessage(ttlsEapACKpkt);
						counterEmptyRecv++;
					}
				}
			}
		}
		return res;
	}

	
	byte[] getTunneledEAPmsg() {
		byte[] rawmsg = null;
		if(tlsResp != null) {
	   		try {
	   			rawmsg = RecordLayer.getApplicationData(tlsResp);
	   		} catch (Exception err) {
	   			DebugInfo.printMessage(1,"===Error! getTunneledEAPmsg Exception: " + err);
	   		}
		}
		return rawmsg;
	}
	
	
	int recvAndParseEAPmsg(EAPpldBasic ttlsEapPkt) {
		int res = 0;
		
		sock.setEapMessage(ttlsEapPkt);

		if(0 != recvFullEAPmsg()) return 1;

		byte[] tlsRaw = EAPTlsFragmentation.combineTlsMessages(tlsMsgList);
		if(tlsRaw == null) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw Null pointer");
		} else if(tlsRaw.length != tlsFullMsgLen) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw length failed: " + tlsRaw.length + " must " + tlsFullMsgLen);
		} else {
			DebugInfo.printDumpWithLength(2, tlsRaw, "Get full tls messages");
		}

		// parse tls response		
		DebugInfo.printMessageWithSeparator(1,"parse tls response");

   		try {
   			tlsResp = tlsClnt.parseTlsResponse(tlsRaw);	
   			if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
   				DebugInfo.printMessage(1,"!!! TLSResponse return error");
   				tlsClnt.conSpec.disconnect();
   				res = 2;
   			}
   		} catch (Exception err) {
   			DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
   			res = 3;
   		}

		return res;
	}

}




