package ru.ispras.telecomtesk.eap.EAPTTLSv0;

import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import ru.ispras.telecomtesk.eap.*;
import ru.ispras.telecomtesk.eap.EAPTLS.EAPTlsFragmentation;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;

import ru.ispras.telecomtesk.tlsv12.Tlsv12Client;
import ru.ispras.telecomtesk.tlsv12.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv12.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv12.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv12.TLSSocket.TLSResponse;
import ru.ispras.telecomtesk.tlsv12.TLSSocket.TLSSocket;
import ru.ispras.telecomtesk.tlsv12.TLSState.*;

import javax.crypto.interfaces.DHPublicKey;





public class trytls
{
    public static void main(String args[]) throws Exception {
    	trytlsRun test1 = new trytlsRun();
    	test1.runtest();
    }
}

class trytlsRun
{
	public static byte[] remoteHostRaw = {(byte)(10),(byte)(10),(byte)(12),(byte)(12)};
	public static byte[] localHostRaw = {(byte)(10),(byte)(10),(byte)(9),(byte)(53)};

	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 6;
		DebugInfo.maxDumpSize = 2000;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 6;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.maxDumpSize = 600;
		
		EAPtype testType = EAPtype.EAP_TYPE_TTLSv0;

		String SharedSecretStr = "testing123";
//		String SharedSecretStr = "secret";
		String userNameStr = "tester";
		String UserPwdStr = "tester"; // "123456";
//		String UserPwdStr = "efqcltpm+>y]";

		System.out.println("sendPacket:" + DebugInfo.debugLevel + " " + DebugInfo.maxDumpSize);
		EAPRadiusSocket sock = new EAPRadiusSocket(SharedSecretStr, userNameStr, remoteHostRaw); 
//		sock.setSocketTimeout(5000);

		Tlsv12Client tlsClnt = new Tlsv12Client();
		
		TLSSocket target = new TLSSocket("192.168.56.23", 9999, 2000);
		
		target.connect();
		TLSResponse resultSock = target.getResponse();

		
		int res;
		boolean cicleFlag;
		EAPheader recvEAP;
		int tlsFullMsgLen = 0;
		ArrayList<byte[]> tlsMsgList = new ArrayList<byte[]>();
		System.out.println("sendPacket:" + DebugInfo.debugLevel + " " + DebugInfo.maxDumpSize);
		
		
// send second message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt2");
		DebugInfo.printMessage(1,"create TLS ClientHello");
		
		byte[] msgCH = tlsClnt.createClientFirstTlsMsg();
		if(msgCH == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client Hello failed");
			target.disconnect();
			return;
		}

		System.out.println("sendTLS mediator");
		target.sendMessage(msgCH);
		resultSock = target.getResponse(); 
		System.out.println("sendTLS mediator return");

// parse tls response		
		DebugInfo.printMessageWithSeparator(1,"parse tls response");
		resultSock.printResponse();
    	if(resultSock.err != 0) {
			DebugInfo.printMessage(1,"!!! TLSResponse return error");
			target.disconnect();
			return;
    	}

    	try {
    		ArrayList<RecordLayer> tlsResp = tlsClnt.parseTlsResponse(resultSock);	
    		if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
    			DebugInfo.printMessage(1,"!!! TLSResponse return error");
    			tlsClnt.conSpec.disconnect();
    			target.disconnect();
    			return;
        	}
    	} catch (Exception err) {
			DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
			target.disconnect();
			return;
		}

		System.out.println("sendPacket:" + DebugInfo.debugLevel + " " + DebugInfo.maxDumpSize);

// send third message		
			DebugInfo.printMessageWithSeparator(1,"try create pkt3");

			byte[] msgSF = tlsClnt.createClientSecondTlsFlow();
			if(msgSF == null) {
				DebugInfo.printMessage(1,"!!! create Tls Client second flow failed");
				target.disconnect();
				return;
			}

			System.out.println("sendTLS mediator");
			target.sendMessage(msgSF);
			resultSock = target.getResponse(); 
			System.out.println("sendTLS mediator return");

		
			// parse tls response		
			DebugInfo.printMessageWithSeparator(1,"parse tls response");
			
			resultSock.printResponse();
	    	if(resultSock.err != 0) {
				DebugInfo.printMessage(1,"!!! TLSResponse return error");
				target.disconnect();
				return;
	    	}

	    	try {
	    		ArrayList<RecordLayer> tlsResp = tlsClnt.parseTlsResponse(resultSock);	
	    		if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
	    			DebugInfo.printMessage(1,"!!! TLSResponse return error");
	    			tlsClnt.conSpec.disconnect();
	    			target.disconnect();
	    			return;
	        	}
	    	} catch (Exception err) {
				DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
				target.disconnect();
				return;
			}

// close socket		
	    target.disconnect();
		sock.closeSocket();
	}

}

