package ru.ispras.telecomtesk.eap.EAPoverLAN;

import ru.ispras.telecomtesk.eap.DebugInfo;

public enum EAPOLEthernetType { 
	ETHERNET_TYPE_UNKNOWN (0x0000),
	ETHERNET_TYPE_EAP_OVER_LAN (0x888e); 
	
	private short type;
	
	private EAPOLEthernetType(int type) {
		this.type = (short)type;
	}
	
	private EAPOLEthernetType(short type) {
		this.type = type;
	}
	
	public short getValue() {
		return type;
	}

	public static EAPOLEthernetType valueOf(int tp) {
		switch ((short)tp) {
		case (short)0x888e: return ETHERNET_TYPE_EAP_OVER_LAN;
		default: return ETHERNET_TYPE_UNKNOWN;
		}
	}

	public static String toString(int tp) {
		EAPOLEthernetType tmpval = EAPOLEthernetType.valueOf(tp);
		String value = "" + tmpval;
		if(tmpval == EAPOLEthernetType.ETHERNET_TYPE_UNKNOWN) {
			String tmpstr = String.format("%04x", tp);
			if(tmpstr.length() > 4)
				tmpstr = tmpstr.substring(tmpstr.length()-4);
			value += "=0x" + tmpstr;
		}
		return value;
	}
}