//
// check second message: EAP-TLS-...-Finished --- ACK message
//

package ru.ispras.telecomtesk.eap.EAPoverLAN;

import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import ru.ispras.telecomtesk.tlsv12.Tlsv12Client;
import ru.ispras.telecomtesk.tlsv12.HandshakeMessages.*;
import ru.ispras.telecomtesk.tlsv12.HandshakeMessages.TLSExtensions.*;
import ru.ispras.telecomtesk.tlsv12.RecordProtocol.*;
import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.*;
import ru.ispras.telecomtesk.tlsv12.TLSSocket.TLSResponse;
import ru.ispras.telecomtesk.tlsv12.TLSState.*;

import javax.crypto.interfaces.DHPublicKey;
import ru.ispras.telecomtesk.eap.*;
import ru.ispras.telecomtesk.eap.EAPPEAP.EAPtypePldPEAP;
import ru.ispras.telecomtesk.eap.EAPTLS.EAPTlsFragmentation;
import ru.ispras.telecomtesk.eap.EAPTTLSv0.EAPtypePldTtlsv0;
import ru.ispras.telecomtesk.eap.EAPTTLSv0.EAPtypePldTtlsv0AVP;
import ru.ispras.telecomtesk.eap.EAPTTLSv0.IteratorRandomAVP;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;
import ru.ispras.telecomtesk.eap.pcap.jPcap;





public class tryEAPOLPeap_tls_2
{
    public static void main(String args[]) throws Exception {
    	tryEAPOLPeap_tls_2_Run test1 = new tryEAPOLPeap_tls_2_Run();
    	test1.runtest();
    }
}

class tryEAPOLPeap_tls_2_Run
{
	byte[] srcMACaddr = {(byte)0x2c,(byte)0x60,(byte)0x0c,(byte)0x92,(byte)0x78,(byte)0xdd}; 
	byte[] dstMACaddr = {(byte)0x01,(byte)0x80,(byte)0xc2,(byte)0x0,(byte)0x0,(byte)0x03};
	EAPOLEthernetHeader	EthPkt = new EAPOLEthernetHeader(srcMACaddr, dstMACaddr, EAPOLEthernetType.ETHERNET_TYPE_EAP_OVER_LAN.getValue());
	
	PrintWriter log1;

	jPcap cpt;

	EAPtype testType = EAPtype.EAP_TYPE_PEAP;

	String SharedSecretStr = "testing123";
//	String SharedSecretStr = "secret";
	String userNameStr = "tester";
//	String userNameStr = "user1-radius";
	String UserPwdStr = "tester"; 
//	String UserPwdStr = "wdcgy159A"; // "123456";
//	String UserPwdStr = "efqcltpm+>y]";

	int waitTimeout = 3000;
	RecordLayer tlsmsg = null;
	int tlsFullMsgLen = 0;
	ArrayList<byte[]> tlsMsgList = null;
	int eapReject = 0, counterSeq = 0, eapNoAnsw = 0;
	boolean tstEap = false;

	EAPOLEthernetHeader	receivedEthPkt;
	EAPOLHeader	receivedEAPOLPkt;
	EAPheader receivedEAPPkt;
	EAPOLHeader	EAPOLPkt;
	
	Tlsv12Client tlsClnt;
	EAPOLTestPeapTLSSequence2 testSeq1;

	ArrayList<RecordLayer> tlsResp;
	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 3;
		DebugInfo.maxDumpSize = 200;
		ru.ispras.telecomtesk.tlsv12.DebugInfo.debugLevel = 3;

		// start capture
				cpt = new jPcap();
				try {
					cpt.startCapture();
				} catch (Exception e) {
					DebugInfo.printMessage(1,"!!!Error. jPcap::startCapture " + e.toString());			
				}

		tlsMsgList = new ArrayList<byte[]>();
		testSeq1 = new EAPOLTestPeapTLSSequence2(userNameStr);
		tlsClnt = new Tlsv12Client();

		int res;
		res = sendPacketsSequence(); 

// close socket		
		cpt.stopCapture();
	}

	
	int sendPacketsSequence() {
		int res = 0;
		
		// send EAPOL Start message		
				DebugInfo.printMessage(1,"try create zero packet");
				
				EAPOLPkt = new EAPOLHeader();
				EAPOLPkt.setStartMessage();
				EthPkt.setData(EAPOLPkt);
				EthPkt.toByteArray();
				sendwaitPacket();

		// send init ID packet
		DebugInfo.printMessage(1,"\n================================================");
		
		EAPpldBasic initEapPkt = new EAPpldBasic();
		initEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		initEapPkt.identifier = receivedEAPPkt.identifier;
		initEapPkt.type = EAPtype.EAP_TYPE_IDENTITY;
		initEapPkt.EAPmethodPld = new EAPtypePldID(userNameStr.getBytes());
		
		setEthernetPkt(initEapPkt);
		sendwaitPacket();

		// send second message		
		DebugInfo.printMessageWithSeparator(1,"create TLS ClientHello");
		byte[] tlsClHello = tlsClnt.createClientFirstTlsMsg();
		if(tlsClHello == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client Hello failed");
			return 2;
		}
		EAPpldBasic ttlsEapPktCH = createEapPkt(new EAPtypePldPEAP(tlsClHello));
		if(0 != recvAndParseEAPmsg(ttlsEapPktCH)) return 3;

    	// send third message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt3");
		byte[] msgSF = tlsClnt.createClientSecondTlsFlow();
		if(msgSF == null) {
			DebugInfo.printMessage(1,"!!! create Tls Client second flow failed");
			return 4;
		}
		EAPpldBasic ttlsEapPktThird = createEapPkt(new EAPtypePldPEAP(msgSF));
		if(0 != recvAndParseEAPmsg(ttlsEapPktThird)) return 5;
    	
		// TLS Handshake complete

	   	// send ACK message		
		DebugInfo.printMessageWithSeparator(1,"try create ack");
		EAPpldBasic ttlsEapPktAck = createEapPkt(new EAPtypePldPEAP());
		DebugInfo.printMessage(1,"**********************************************************");
		recvAndParseEAPmsg(ttlsEapPktAck);

	   	// send fourth message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt4 under TLS");
		byte[] innerEapFstMsg = {13}; //testSeq1.setTestPld();
		byte[] tlsAppl = tlsClnt.createApplicationData(innerEapFstMsg);
		EAPpldBasic ttlsEapPktApp = createEapPkt(new EAPtypePldPEAP(tlsAppl));
		DebugInfo.printMessage(1,"**********************************************************");
		tstEap = true;
		if(0 != recvAndParseEAPmsg(ttlsEapPktApp)) return 7;
		tstEap = false;

		return res;
	}

	void setEthernetPkt(EAPpldBasic eappld) {
		EAPOLPkt = new EAPOLHeader(eappld);
		EthPkt.setData(EAPOLPkt);
		EthPkt.toByteArray();
	}

	EAPpldBasic createEapPkt(EAPtypePldPEAP ttlspld) {
		EAPpldBasic testEapPkt = new EAPpldBasic();
		testEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		testEapPkt.identifier = receivedEAPPkt.identifier;
		testEapPkt.type = testType;
		testEapPkt.EAPmethodPld = ttlspld;
		testEapPkt.isLengthSet = false;
		testEapPkt.toByteArray();
		return testEapPkt;
	}


	int recvFullEAPmsg() {
		int res = 0;
		tlsMsgList.clear();
		boolean cicleFlag;
		tlsFullMsgLen = 0;
		cicleFlag = true;
		int counterEmptyRecv = 0;
		EAPpldBasic ttlsEapACKpkt = new EAPpldBasic();
		
		ttlsEapACKpkt.code = EAPcode.EAP_CODE_RESPONSE;
		ttlsEapACKpkt.type = testType;

		while(cicleFlag) {
			sendwaitPacket();
			if(receivedEAPPkt == null) { 
				DebugInfo.printMessage(1,"!!! sendEAPpacket failed");
				return 1;
			}
			if(tstEap) {
				if(receivedEthPkt == null)
					eapNoAnsw ++;
				if(receivedEAPPkt.code == EAPcode.EAP_CODE_FAILURE)
					eapReject ++;
			}
			cicleFlag = false;

			if(receivedEAPPkt instanceof EAPpldBasic) {
				if(((EAPpldBasic) receivedEAPPkt).type == testType) {
					EAPtypePldPEAP curpld = (EAPtypePldPEAP)((EAPpldBasic)receivedEAPPkt).EAPmethodPld;
					if(curpld.getEapTlsLBit()) {
						if(tlsFullMsgLen == 0)
							tlsFullMsgLen = curpld.tlsMessageLenght;
						else {
							DebugInfo.printMessage(1,"!!! Warning! tlsMessageLenght dublicate");
						}
					}
					tlsMsgList.add(curpld.tlsData);
					if(curpld.getEapTlsMBit()) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = receivedEAPPkt.identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldPEAP();
						ttlsEapACKpkt.isLengthSet = false;
						ttlsEapACKpkt.toByteArray();
						setEthernetPkt(ttlsEapACKpkt);
					} else if((curpld.tlsData == null) || (curpld.tlsData.length == 0)) {
						cicleFlag = true;
						ttlsEapACKpkt.identifier = receivedEAPPkt.identifier;
						ttlsEapACKpkt.EAPmethodPld = new EAPtypePldPEAP();
						ttlsEapACKpkt.isLengthSet = false;
						if(counterEmptyRecv > 0)
							((EAPtypePldPEAP)(ttlsEapACKpkt.EAPmethodPld)).setEapTlsFlag(true,false,false);
						ttlsEapACKpkt.toByteArray();
						setEthernetPkt(ttlsEapACKpkt);
						counterEmptyRecv++;
					}
				}
			}
		}
		return res;
	}

	
	int parseTLSresp(byte[] tlsmsg) {
		DebugInfo.printMessageWithSeparator(1,"parse tls response");
		int res = 0;
		
		TLSResponse resp = new TLSResponse(tlsmsg);
   		resp.printResponse();
    	if(resp.err != 0) {
			DebugInfo.printMessage(1,"!!! TLSResponse return error");
			res = 1;
    	} else {
    		try {
    			ArrayList<RecordLayer> tlsResp = tlsClnt.parseTlsResponse(resp);	
    			if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
    				DebugInfo.printMessage(1,"!!! TLSResponse return error");
    				tlsClnt.conSpec.disconnect();
    				res = 2;
    			}
    		} catch (Exception err) {
    			DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
    			res = 3;
    		}
    	}
    	return res;
	}

	int recvAndParseEAPmsg(EAPpldBasic ttlsEapPkt) {
		int res = 0;
		
		setEthernetPkt(ttlsEapPkt);

		if(0 != recvFullEAPmsg()) return 1;

		byte[] tlsRaw = EAPTlsFragmentation.combineTlsMessages(tlsMsgList);
		if(tlsRaw == null) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw Null pointer");
		} else if(tlsRaw.length != tlsFullMsgLen) {
			DebugInfo.printMessage(1,"!!! Error! tlsRaw length failed: " + tlsRaw.length + " must " + tlsFullMsgLen);
		} else {
			DebugInfo.printDumpWithLength(2, tlsRaw, "Get full tls messages");
		}

		// parse tls response		
		DebugInfo.printMessageWithSeparator(1,"parse tls response");

   		try {
   			tlsResp = tlsClnt.parseTlsResponse(tlsRaw);	
   			if(null == tlsResp  ||  tlsClnt.conSpec.disconnectWithSendAlert != -1) {
   				DebugInfo.printMessage(1,"!!! TLSResponse return error");
   				tlsClnt.conSpec.disconnect();
   				res = 2;
   			}
   		} catch (Exception err) {
   			DebugInfo.printMessage(1,"===Error! parseTlsResponse Exception: " + err);
   			res = 3;
   		}

		return res;
	}

	void sendwaitPacket() {
		sendPacket();
		if(cpt.receivedPacket == null) {
			DebugInfo.printMessage(1,"parseRecvMessage: received no packets");
			DebugInfo.printMessage(1,"try send packet again");
			sendPacket();

			if(cpt.receivedPacket == null) {
				DebugInfo.printMessage(1,"parseRecvMessage: received no packets");
				cpt.stopCapture();
				return;
			}
		}
		parseRecvMessage();
	}

	void sendPacket() {
		DebugInfo.printDump(1, EthPkt.net_msg, "sendPacket: Sending packet:");

		try {
			cpt.sendPacket(EthPkt.net_msg);
			DebugInfo.printMessage(1,"packet has been sended");
			Thread.sleep(waitTimeout);
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::sendPacket " + e.toString());			
		}
	}

	int parseRecvMessage() {
		int res = 0;
		
		DebugInfo.printDump(2, cpt.receivedPacket, 0, cpt.receivedPacket.length , "parseRecvMessage: received bytes " + cpt.receivedPacket.length);

		// parse received message
		receivedEthPkt = new EAPOLEthernetHeader();
		receivedEthPkt.net_msg = new byte[cpt.receivedPacket.length];
		System.arraycopy(cpt.receivedPacket, 0, receivedEthPkt.net_msg, 0, cpt.receivedPacket.length);
		res = receivedEthPkt.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res);
		receivedEthPkt.print();

		// get EAPOL received message
		receivedEAPOLPkt = null;
		if(receivedEthPkt.type == EAPOLEthernetType.ETHERNET_TYPE_EAP_OVER_LAN.getValue())
			receivedEAPOLPkt = (EAPOLHeader)receivedEthPkt.data;

		// get EAP received message
		receivedEAPPkt = null;
		if(receivedEAPOLPkt.type == EAPOLtype.EAPOL_TYPE_PACKET.getValue())
			receivedEAPPkt = (EAPheader)receivedEAPOLPkt.data;
		
		cpt.receivedPacket = null;

		if(receivedEAPPkt == null) {
			DebugInfo.printMessage(1,"parseRecvMessage: no EAP packet");
			return res+1;
		} else if(receivedEAPPkt instanceof EAPpldBasic == false) {
			DebugInfo.printMessage(1,"parseRecvMessage: managed EAP packet");
			return res+1;
		}

		return res;
	}
}




class EAPOLTestPeapTLSSequence2
{
	byte[] testRandomData = {1,2,3,4,5,6,7,8};
	byte[] testRandomMD5Data = {16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	byte[] testRandomMSCHAPData = null;
	byte[] testRandomExpandedData = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
	byte[] testRandomSimData = {10,0,0,7,5,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,16,1,0,1};
	byte[] testRandomTLSData = {0,22,3,3,0,57,1,0,0,53,3,3,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,0,0,4,0,47,0,61,1,0,0,8,0,13,0,4,0,2,2,1};


	String userName = null;
	
	TestIterator itrInnerEapType;
	TestIterator itrInnerEapData;
	TestIteratorComlex itrMain;
	boolean endFlag;

	EAPOLTestPeapTLSSequence2(String userName) {
		this.userName = userName;
		itrInnerEapType = new TestIterator();
		itrInnerEapData = new TestIterator();
		TestIterator[] itrArray = {itrInnerEapType,itrInnerEapData};
		itrMain = new TestIteratorComlex(itrArray);
		endFlag = false;
		
		EAPtypePldMSCHAP msPld = new EAPtypePldMSCHAP();
		msPld.setRandomNTvalue();
		testRandomMSCHAPData = msPld.value;
	}
	
    public boolean isEnd() {
    	return this.endFlag;
    }

    public void printIteratorIndexes() {
		DebugInfo.printMessage(1,"itrInnerEapType itrInnerEapData " + itrInnerEapType.index + " "  + itrInnerEapData.index);
    }
    
    public void clear() {
		itrInnerEapType.clear();
		itrInnerEapData.clear();
		itrMain.clear();
    }

	public byte[] setTestPld() {
		DebugInfo.printMessage(1,"setTestPld");
		EAPtype curTp;
		byte[] dt;
		byte[] pld = null;

		printIteratorIndexes();
		curTp = getInnerEapType(itrInnerEapType);
		dt = getInnerEapData(itrInnerEapData,curTp);
		if(!itrMain.next()) this.endFlag = true;

		if(dt != null) {
			pld = new byte[1 + dt.length];
			System.arraycopy(dt, 0, pld, 1, dt.length);
		}
		else {
			pld = new byte[1];
		}
		pld[0] = (byte)curTp.getValue();
		
		DebugInfo.printMessage(1,"setTestPld return");
		return pld;
	}
	
	EAPtype getInnerEapType(TestIterator itr) {
		switch (itr.index) {
		case 1: return EAPtype.EAP_TYPE_UNKNOWN;
		case 2: return EAPtype.EAP_TYPE_NOTIFICATION;
		case 3:	return EAPtype.EAP_TYPE_NAK;
		case 4:	return EAPtype.EAP_TYPE_TEST;
		case 5:	return EAPtype.EAP_TYPE_EXPANDED_TYPES;
		case 6:	return EAPtype.EAP_TYPE_EXPERIMENTAL;
		case 7:	return EAPtype.EAP_TYPE_MD5CHALLENGE;
		case 8:	return EAPtype.EAP_TYPE_MSCHAP;
		case 9:	return EAPtype.EAP_TYPE_SIM;
		case 10: return EAPtype.EAP_TYPE_TLS;
		case 11: return EAPtype.EAP_TYPE_TTLSv0;
		case 12: return EAPtype.EAP_TYPE_PEAP;
		case 13: itr.end(); return EAPtype.EAP_TYPE_IDENTITY;
		default: itr.end(); return EAPtype.EAP_TYPE_UNKNOWN;
		}
	}

	
	byte[] getInnerEapData(TestIterator itr, EAPtype tp) {
		byte[] pldData = null;
		
		switch (itr.index) {
		case 1:	break;
		case 2:	pldData = testRandomData; break;
		case 3:	
			switch (tp) {
			case EAP_TYPE_IDENTITY: pldData = userName.getBytes(); break;
			case EAP_TYPE_NAK: pldData = new byte[1]; pldData[0] = 0; break;
			case EAP_TYPE_EXPANDED_TYPES: pldData = testRandomExpandedData;  break;
			case EAP_TYPE_MD5CHALLENGE:	pldData = testRandomMD5Data;  break;
			case EAP_TYPE_MSCHAP:	pldData = testRandomMSCHAPData;  break;
			case EAP_TYPE_SIM:	pldData = testRandomSimData;  break;
			case EAP_TYPE_TLS:
			case EAP_TYPE_PEAP:	
			case EAP_TYPE_TTLSv0:	pldData = testRandomTLSData;;  break;
			}
			itr.end(); break;
		default: itr.end(); 
		}
		return pldData;
	}
	
}
