package ru.ispras.telecomtesk.eap.EAPoverLAN;

import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import javax.crypto.interfaces.DHPublicKey;

import ru.ispras.telecomtesk.eap.DebugInfo;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;
import ru.ispras.telecomtesk.eap.EAPcode;
import ru.ispras.telecomtesk.eap.EAPheader;
import ru.ispras.telecomtesk.eap.EAPpldBasic;
import ru.ispras.telecomtesk.eap.EAPtype;
import ru.ispras.telecomtesk.eap.EAPtypePldID;
import ru.ispras.telecomtesk.eap.EAPtypePldMd5;
import ru.ispras.telecomtesk.eap.EAPSIM.*;
import ru.ispras.telecomtesk.eap.EAPSIM.Attributes.*;
import ru.ispras.telecomtesk.eap.pcap.jPcap;

public class tryEAPOLinit
{
    public static void main(String args[]) throws Exception {
    	tryEAPOLinitRun test1 = new tryEAPOLinitRun();
    	test1.runtest();
    }
}

class tryEAPOLinitRun
{
	public static byte[] sendData = new byte[65000];
	public static int sendDataLength = 0;
	public static byte[] receiveData = new byte[65000];
	public static int receiveDataLength = 0;

	byte[] receivePacket;
	EAPOLEthernetHeader	receivedEthPkt;
	EAPOLHeader	receivedEAPOLPkt;
	EAPheader receivedEAPPkt;
	
	jPcap cpt;
	
	static byte[] localRand1 = {(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34};
	static byte[] localRand2 = {0x20,0x01,0x00,0x00,0x05,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand3 = {(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a};
	static byte[] localRand4 = {0x20,0x01,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand5 = {(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab};
	static byte[] localKc1 = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
	static byte[] localKc2 = {0x30,0x01,0x00,0x00,0x00,0x00,0x00,0x52};
	static byte[] localKc3 = {0x10,0x21,0x32,0x43,0x54,0x65,0x76,(byte)0x87};
	static byte[] localKc4 = {0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localKc5 = {0x30,0x41,0x52,0x63,0x74,(byte)0x85,(byte)0x96,(byte)0xa7};
	static byte[] localSres1 = {0x12,0x34,(byte)0xab,(byte)0xcd};
	static byte[] localSres2 = {0x23,0x43,0x13,0x11};
	static byte[] localSres3 = {0x23,0x4a,(byte)0xbc,(byte)0xd1};
	static byte[] localSres4 = {0x33,0x33,0x13,0x11};
	static byte[] localSres5 = {0x34,(byte)0xab,(byte)0xcd,0x12};
	EAPsimTriplets localTriplets = new EAPsimTriplets();
    EAPsimGSMtriplet gsmTrpl1 = new EAPsimGSMtriplet(localRand1,localKc1,localSres1);
    EAPsimGSMtriplet gsmTrpl2 = new EAPsimGSMtriplet(localRand2,localKc2,localSres2);
    EAPsimGSMtriplet gsmTrpl3 = new EAPsimGSMtriplet(localRand3,localKc3,localSres3);
    EAPsimGSMtriplet gsmTrpl4 = new EAPsimGSMtriplet(localRand4,localKc4,localSres4);
    EAPsimGSMtriplet gsmTrpl5 = new EAPsimGSMtriplet(localRand5,localKc5,localSres5);

    public void runtest() throws Exception {
		DebugInfo.debugLevel = 2;
		DebugInfo.maxDumpSize = 1000;

		String UserPwdStr = "123456";
//		String UserPwdStr = "wdcgy159A"; // "123456";
		byte[] UserPwd = UserPwdStr.getBytes();
//		String userNameStr = "tester";
		String userNameStr = "testereapsim";
		byte[] userName = userNameStr.getBytes();

		byte[] srcMACaddr = {(byte)0x2c,(byte)0x60,(byte)0x0c,(byte)0x92,(byte)0x78,(byte)0xdd}; 
		byte[] dstMACaddr = {(byte)0x01,(byte)0x80,(byte)0xc2,(byte)0x0,(byte)0x0,(byte)0x03};
		EAPOLEthernetHeader	EthPkt = new EAPOLEthernetHeader(srcMACaddr, dstMACaddr, EAPOLEthernetType.ETHERNET_TYPE_EAP_OVER_LAN.getValue());

// start capture
		cpt = new jPcap();
		try {
			cpt.startCapture();
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::startCapture " + e.toString());			
		}

// send first message		
		DebugInfo.printMessage(1,"try create first packet");
		
		EAPOLHeader	EAPOLPkt = new EAPOLHeader();
		EAPOLPkt.setStartMessage();
		EthPkt.setData(EAPOLPkt);

		EthPkt.toByteArray();

		int res = 0;
	    int res1;

		DebugInfo.printDump(1, EthPkt.net_msg, "Sending first Ethernet packet:");

		try {
			cpt.sendPacket(EthPkt.net_msg);
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::sendPacket " + e.toString());			
		}

		DebugInfo.printMessage(1,"packet has been sended");
		Thread.sleep(2000);

// parse received message		
		res = parseRecvMessage();
		if(res != 0) {
			cpt.stopCapture();
			return;
		}
		
// send second message		
		DebugInfo.printMessage(1,"try create second packet");

		EAPpldBasic initEapPkt = new EAPpldBasic();
		initEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		initEapPkt.identifier = receivedEAPPkt.identifier;
		initEapPkt.type = EAPtype.EAP_TYPE_IDENTITY;
		initEapPkt.EAPmethodPld = new EAPtypePldID(userName);
		
		EAPOLHeader	EAPOLPkt2 = new EAPOLHeader(initEapPkt);
		EthPkt.setData(EAPOLPkt2);

		EthPkt.toByteArray();

		DebugInfo.printDump(1, EthPkt.net_msg, "Sending second Ethernet packet");

		try {
			cpt.sendPacket(EthPkt.net_msg);
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::sendPacket " + e.toString());			
		}

		DebugInfo.printMessage(1,"packet has been sended");
		Thread.sleep(2000);


// parse received message		
		res = parseRecvMessage();
		if(res != 0) {
			cpt.stopCapture();
			return;
		}
		
		
// send third message		
		DebugInfo.printMessage(1,"try create third packet");

		EAPpldBasic eapPkt1 = new EAPpldBasic();
		eapPkt1.code = EAPcode.EAP_CODE_RESPONSE;
		eapPkt1.identifier = receivedEAPPkt.identifier;

        EAPsimAttrNonceMT nmt = null;
       	EAPsimAttrIdentity sid = null;
       	EAPsimAttrSelectedVersion sv = null;
       	EAPsimAttrVersionList recvVerList = null;
       	
       	if(receivedEAPPkt instanceof EAPpldBasic) {
			eapPkt1.type = ((EAPpldBasic)receivedEAPPkt).type;
			
			if(eapPkt1.type == EAPtype.EAP_TYPE_MD5CHALLENGE) {
		        EAPtypePldMd5 eapPldMd5 = new EAPtypePldMd5();
		        eapPldMd5.setMD5value(eapPkt1.identifier, ((EAPtypePldMd5)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld)).value, UserPwd);
		        eapPkt1.EAPmethodPld = eapPldMd5;				
			} else if(eapPkt1.type == EAPtype.EAP_TYPE_SIM) {
				EAPtypePldSim eapPldSimRecvStart = null;
				
                eapPldSimRecvStart = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
                recvVerList = 
		                	(EAPsimAttrVersionList)(eapPldSimRecvStart.getAttributeByType(EAPsimAttrType.EAPSIM_AT_VERSION_LIST.getValue()));

		        EAPtypePldSim eapPldSimStart = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_START.getValue());
		        nmt = new EAPsimAttrNonceMT();
		       	sv = new EAPsimAttrSelectedVersion((short)1);
		       	sv.checkValue(recvVerList.versionList);
		       	sid = new EAPsimAttrIdentity(userName);
		       	eapPldSimStart.addAttribute(sid);
		       	eapPldSimStart.addAttribute(nmt);
		       	eapPldSimStart.addAttribute(sv);
		       	eapPkt1.EAPmethodPld = eapPldSimStart;
			} else {
				DebugInfo.printMessage(1,"!!!Error! create: unknown EAP type");
				cpt.stopCapture();
				return;			
			}
		} else {
			DebugInfo.printMessage(1,"!!!Error! create: unknown EAP packet");
			cpt.stopCapture();
			return;			
		}
		
		EAPOLHeader	EAPOLPkt3 = new EAPOLHeader(eapPkt1);
		EthPkt.setData(EAPOLPkt3);

		EthPkt.toByteArray();

		DebugInfo.printDump(1, EthPkt.net_msg, "Sending third Ethernet packet");

		try {
			cpt.sendPacket(EthPkt.net_msg);
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::sendPacket " + e.toString());			
		}

		DebugInfo.printMessage(1,"packet has been sended");
		Thread.sleep(2000);

// parse received message		
		res = parseRecvMessage();
		if(res != 0) {
			cpt.stopCapture();
			return;
		}


// send fourth message		
		DebugInfo.printMessage(1,"try create fourth packet");

		EAPpldBasic eapPkt2 = new EAPpldBasic();
		eapPkt2.code = EAPcode.EAP_CODE_RESPONSE;
		eapPkt2.identifier = receivedEAPPkt.identifier;

		if(receivedEAPPkt instanceof EAPpldBasic) {
			eapPkt2.type = ((EAPpldBasic)receivedEAPPkt).type;
			
			if(eapPkt2.type == EAPtype.EAP_TYPE_SIM) {
				EAPtypePldSim eapPldSimRecvClg = null;
				EAPsimAttrRand recvRand = null;
                EAPsimAttrMAC recvMAC = null;
				
                localTriplets.addTriplet(gsmTrpl1);
                localTriplets.addTriplet(gsmTrpl2);
                localTriplets.addTriplet(gsmTrpl3);
                localTriplets.addTriplet(gsmTrpl4);
                localTriplets.addTriplet(gsmTrpl5);
                
                int recvMacPosition = 0;

                eapPldSimRecvClg = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
                recvMacPosition = eapPldSimRecvClg.parsedMACposition;
                recvRand = 
                	(EAPsimAttrRand)(eapPldSimRecvClg.getAttributeByType(EAPsimAttrType.EAPSIM_AT_RAND.getValue()));
                recvMAC = 
                	(EAPsimAttrMAC)(eapPldSimRecvClg.getAttributeByType(EAPsimAttrType.EAPSIM_AT_MAC.getValue()));

                EAPsimTriplets curtrpl = localTriplets.getTripletByRand(recvRand.attrData);

                byte[] nKcKEY = curtrpl.combineAllKc();
                byte[] nSresKEY = curtrpl.combineAllSres();

                DebugInfo.printDump(1, nKcKEY, "nKcKEY:");
                DebugInfo.printDump(1, nSresKEY, "nSresKEY:");
                
               	byte[] newMK = EAPsimSecurity.createMasterKey(sid.value, nKcKEY, nmt.attrData, recvVerList.versionListToByteArray(), sv.value);
                DebugInfo.printDump(1, newMK, "MasterKey:");
        		byte[] newKeysArray = EAPsimSecurity.eapSimPRF(newMK, 160);
        		DebugInfo.printDump(3, newKeysArray, "newKeysArray:");

        		byte[] newKauth = new byte[16];
                System.arraycopy(newKeysArray, 16, newKauth, 0, newKauth.length);

        		byte[] recvDataForMac = new byte[receivedEAPPkt.net_msg.length + nmt.attrData.length];
                System.arraycopy(receivedEAPPkt.net_msg, 0, recvDataForMac, 0, receivedEAPPkt.net_msg.length);
                for(int j=0; j<16; j++)
                	recvDataForMac[recvMacPosition + j] = 0;
                System.arraycopy(nmt.attrData, 0, recvDataForMac, receivedEAPPkt.net_msg.length, nmt.attrData.length);
                byte[] calcMAC = EAPsimSecurity.mac(recvDataForMac, newKauth);
                EAPsimSecurity.compareMac(recvMAC.attrData, calcMAC);
        		
                EAPtypePldSim eapPldSimClg = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_CHALLENGE.getValue());
                EAPsimAttrMAC mac3 = new EAPsimAttrMAC();
               	eapPldSimClg.addAttribute(mac3);

               	eapPkt2.EAPmethodPld = eapPldSimClg;
               	eapPkt2.toByteArray();

                recvDataForMac = new byte[eapPkt2.net_msg.length + nSresKEY.length];
                System.arraycopy(eapPkt2.net_msg, 0, recvDataForMac, 0, eapPkt2.net_msg.length);
                System.arraycopy(nSresKEY, 0, recvDataForMac, eapPkt2.net_msg.length, nSresKEY.length);
                calcMAC = EAPsimSecurity.mac(recvDataForMac, newKauth);
                System.arraycopy(calcMAC, 0, mac3.attrData, 0, calcMAC.length);
                mac3.toByteArray();               	
			} else {
				DebugInfo.printMessage(1,"!!!Error! create: unknown EAP type");
				cpt.stopCapture();
				return;			
			}
		} else {
			DebugInfo.printMessage(1,"!!!Error! create: unknown EAP packet");
			cpt.stopCapture();
			return;			
		}
		
		EAPOLHeader	EAPOLPkt4 = new EAPOLHeader(eapPkt2);
		EthPkt.setData(EAPOLPkt4);

		EthPkt.toByteArray();

		DebugInfo.printDump(1, EthPkt.net_msg, "Sending fourth Ethernet packet");

		try {
			cpt.sendPacket(EthPkt.net_msg);
		} catch (Exception e) {
			DebugInfo.printMessage(1,"!!!Error. jPcap::sendPacket " + e.toString());			
		}

		DebugInfo.printMessage(1,"packet has been sended");
		Thread.sleep(2000);

// parse received message		
		res = parseRecvMessage();
		if(res != 0) {
			cpt.stopCapture();
			return;
		}

		
// close socket
		cpt.stopCapture();
		DebugInfo.printMessage(1,"socket closed");
	}

	
	int parseRecvMessage() {
		int res = 0;
		
		if(cpt.receivedPacket == null) {
			DebugInfo.printMessage(1,"parseRecvMessage: received no packets");
			return 1;
		}

		DebugInfo.printDump(2, cpt.receivedPacket, 0, cpt.receivedPacket.length , "parseRecvMessage: received bytes " + cpt.receivedPacket.length);

		// parse received message
		receivedEthPkt = new EAPOLEthernetHeader();
		receivedEthPkt.net_msg = new byte[cpt.receivedPacket.length];
		System.arraycopy(cpt.receivedPacket, 0, receivedEthPkt.net_msg, 0, cpt.receivedPacket.length);
		res = receivedEthPkt.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res);
		receivedEthPkt.print();

		// get EAPOL received message
		receivedEAPOLPkt = null;
		if(receivedEthPkt.type == EAPOLEthernetType.ETHERNET_TYPE_EAP_OVER_LAN.getValue())
			receivedEAPOLPkt = (EAPOLHeader)receivedEthPkt.data;

		// get EAP received message
		receivedEAPPkt = null;
		if(receivedEAPOLPkt.type == EAPOLtype.EAPOL_TYPE_PACKET.getValue())
			receivedEAPPkt = (EAPheader)receivedEAPOLPkt.data;
		
		cpt.receivedPacket = null;

		if(receivedEAPPkt == null) {
			DebugInfo.printMessage(1,"parseRecvMessage: no EAP packet");
			return res+1;
		} else if(receivedEAPPkt instanceof EAPpldBasic == false) {
			DebugInfo.printMessage(1,"parseRecvMessage: managed EAP packet");
			return res+1;
		}

		return res;
	}

}

