package ru.ispras.telecomtesk.eap.EAPoverRadius;

public enum RadiusAttributeType { 
	RADIUS_ATTRIBUTE_UNKNOWN(0),
	RADIUS_ATTRIBUTE_REPLY_MESSAGE(18),
	RADIUS_ATTRIBUTE_STATE(24),
	RADIUS_ATTRIBUTE_EAP_MESSAGE(79),
	RADIUS_ATTRIBUTE_MESSAGE_AUTHENTICATOR(80),
	RADIUS_ATTRIBUTE_RESERVED(255);
	
	public byte type;
	
	private RadiusAttributeType(int type) {
		this.type = (byte)type;
	}
	
	private RadiusAttributeType(byte type) {
		this.type = type;
	}
	
	public byte getValue() {
		return type;
	}
	
	public static RadiusAttributeType valueOf(byte tp) {
		switch (tp) {
		case 18: return RADIUS_ATTRIBUTE_REPLY_MESSAGE;
		case 24: return RADIUS_ATTRIBUTE_STATE;
		case 79: return RADIUS_ATTRIBUTE_EAP_MESSAGE;
		case 80: return RADIUS_ATTRIBUTE_MESSAGE_AUTHENTICATOR;
		default: return RADIUS_ATTRIBUTE_UNKNOWN;
		}
	}

	public static RadiusAttributeType valueOf(int tp) {
		return valueOf((byte)tp);
	}
}