package ru.ispras.telecomtesk.eap.EAPoverRadius;

public enum RadiusCode { 
	RADIUS_CODE_UNKNOWN(0),
	RADIUS_CODE_ACCESS_REQUEST(1),
	RADIUS_CODE_ACCESS_ACCEPT(2),
	RADIUS_CODE_ACCESS_REJECT(3),
	RADIUS_CODE_ACCOUNTING_REQUEST(4),
	RADIUS_CODE_ACCOUNTING_RESPONSE(5),
	RADIUS_CODE_ACCESS_CHALLENGE(11),
	RADIUS_CODE_STATUS_SERVER(12),
	RADIUS_CODE_STATUS_CLIENT(13),
	RADIUS_CODE_RESERVED(255);
	
	public byte type;
	
	private RadiusCode(int type) {
		this.type = (byte)type;
	}
	
	private RadiusCode(byte type) {
		this.type = type;
	}
	
	public byte getValue() {
		return type;
	}
	
	public static RadiusCode valueOf(byte tp) {
		switch (tp) {
		case 1: return RADIUS_CODE_ACCESS_REQUEST;
		case 2:	return RADIUS_CODE_ACCESS_ACCEPT;
		case 3:	return RADIUS_CODE_ACCESS_REJECT;
		case 4:	return RADIUS_CODE_ACCOUNTING_REQUEST;
		case 5:	return RADIUS_CODE_ACCOUNTING_RESPONSE;
		case 11: return RADIUS_CODE_ACCESS_CHALLENGE;
		case 12: return RADIUS_CODE_STATUS_SERVER;
		case 13: return RADIUS_CODE_STATUS_CLIENT;
		default: return RADIUS_CODE_UNKNOWN;
		}
	}

	public static RadiusCode valueOf(int tp) {
		return valueOf((byte)tp);
	}
}