package ru.ispras.telecomtesk.eap;

public enum EAPtype { 
	EAP_TYPE_UNKNOWN(0),
	EAP_TYPE_IDENTITY(1),
	EAP_TYPE_NOTIFICATION(2),
	EAP_TYPE_NAK(3),
	EAP_TYPE_MD5CHALLENGE(4),
	EAP_TYPE_ONE_TIME_PASSWORD(5),
	EAP_TYPE_GENERIC_TOKEN_CARD(6),
	EAP_TYPE_TLS(13),
	EAP_TYPE_SIM(18),
	EAP_TYPE_TTLSv0(21),
	EAP_TYPE_PEAP(25),
	EAP_TYPE_MSCHAP(26),
	EAP_TYPE_TEST(130),
	EAP_TYPE_EXPANDED_TYPES(254),
	EAP_TYPE_EXPERIMENTAL(255);
	
	public int type;
	
	private EAPtype(int type) {
		this.type = type;
	}
	
	public int getValue() {
		return type;
	}

	public static EAPtype valueOf(int tp) {
		switch (tp) {
		case 0:	return EAP_TYPE_UNKNOWN;
		case 1: return EAP_TYPE_IDENTITY;
		case 2:	return EAP_TYPE_NOTIFICATION;
		case 3:	return EAP_TYPE_NAK;
		case 4:	return EAP_TYPE_MD5CHALLENGE;
		case 5:	return EAP_TYPE_ONE_TIME_PASSWORD;
		case 6:	return EAP_TYPE_GENERIC_TOKEN_CARD;
		case 13:  return EAP_TYPE_TLS;
		case 18:  return EAP_TYPE_SIM;
		case 21:  return EAP_TYPE_TTLSv0;
		case 25:  return EAP_TYPE_PEAP;
		case 26:  return EAP_TYPE_MSCHAP;
		case 130: return EAP_TYPE_TEST;
		case 254: return EAP_TYPE_EXPANDED_TYPES;
		default: return EAP_TYPE_EXPERIMENTAL;
		}
	}
}