package ru.ispras.telecomtesk.eap;

import java.io.*;
import java.net.*;

import ru.ispras.telecomtesk.eap.EAPPEAP.EAPtypePldPEAP;
import ru.ispras.telecomtesk.eap.EAPoverRadius.*;

public class testEAP2_peap
{
    public static void main(String args[]) throws Exception {
    	testEAP2runPEAP test2 = new testEAP2runPEAP();
    	test2.runtest();
    }
}

class testEAP2runPEAP
{
	public static int destination_port = 1812; 

	public static byte[] sendData = new byte[65000];
	public static int sendDataLength = 0;
	public static byte[] receiveData = new byte[65000];
	public static int receiveDataLength = 0;

	public static InetAddress remoteIPAddress;
	public static String remoteHost = "192.168.160.55";
	public static byte[] remoteHostRaw = {(byte)(192),(byte)(168),(byte)(56),(byte)(101)};
	public static byte[] localHostRaw = {(byte)(192),(byte)(168),(byte)(160),(byte)(1)};

	DatagramSocket clientSocket;
	DatagramPacket sendPacket;
	DatagramPacket receivePacket;

	byte[] SharedSecret;
	byte[] UserPwd;
	String userName;

	int numberSendWrongPkts = 1;
	int numberSendRightPkts = 1;

	int counterRadiusPkt = 1;
	int counterEAPPkt = 1;
	EAPRadiusHeader radiusPkt;
	EAPRadiusAttributes radAttr_name;
	EAPRadiusAttributes radAttr_auth;

	EAPRadiusHeader	receivedRadPkt;
	EAPheader receivedEAPPkt;
    
	EAPpldBasic eapInitMsg;
	EAPRadiusAttributes radAttr_eap_init;
	EAPpldBasic eapSecondMsg;
	EAPRadiusAttributes radAttr_eap_second;
	EAPRadiusAttributes radAttr_state;

	int counterWrongPackets1 = 0;
	int counterWrongPackets2 = 0;
    
	byte[] testRandomData = {1,2,3,4,5,6,7,8};
	byte[] testRandomMD5Data = {16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	byte[] testRandomExpandedData = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
	byte[] testExpandedNak = {(byte)254,0,0,0,0,0,0,4,(byte)254,0,0,0,0,0,0,0};
	byte[] testExpandedData = {0,0,0,0,0,0,(byte)254,0,0,0,0,0,0,1};
	
	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 2;
		DebugInfo.maxDumpSize = 1000;

		clientSocket = new DatagramSocket();
		clientSocket.setSoTimeout(5000);
		remoteIPAddress = InetAddress.getByAddress(remoteHostRaw);
		receivePacket = new DatagramPacket(receiveData, receiveData.length);

		String SharedSecretStr = "testing123";
		SharedSecret = SharedSecretStr.getBytes();
		String UserPwdStr = "123456";
		UserPwd = UserPwdStr.getBytes();

		radiusPkt = new EAPRadiusHeader(1,counterRadiusPkt);
		
	    radAttr_name = new EAPRadiusAttributes(1);
		userName = "sqltest";
		radAttr_name.value = userName.getBytes();

	    radAttr_auth = new EAPRadiusAttributes(80);
		
	    eapInitMsg = new EAPpldResponse(counterEAPPkt++, EAPtype.EAP_TYPE_IDENTITY);
	    eapInitMsg.EAPmethodPld = new EAPtypePldID(userName.getBytes());
	    eapInitMsg.toByteArray();
		radAttr_eap_init = new EAPRadiusAttributes(79,eapInitMsg.net_msg);
        
	
	    int eapCode;
	    int eapType;
	    int eapId;
	    int eapLenth;
	    int eapData;
	    int eapState;
	    int result;


// iterate second sending packet
	    
	    for (eapCode = 1; eapCode <= 5; eapCode++) {
		    for (eapId = 1; eapId <= 2; eapId++) {
			    for (eapLenth = 1; eapLenth <= 6; eapLenth++) {
				    for (eapData = 1; eapData <= 2; eapData++) {
				    	for (eapState = 1; eapState <= 2; eapState++) {
				    		result = sendPacketsSequence(eapCode,eapId,eapLenth,eapData,-1,eapState);
				    		if(result > 1) {
				    			clientSocket.close();
				    			DebugInfo.printMessage(1,"socket closed, stop test");
				    			return;
				    		}
				    	}
				    }
			    }
		    }
	    }

	    for (eapCode = 6; eapCode <= 7; eapCode++) {
		    for (eapId = 1; eapId <= 2; eapId++) {
			    for (eapLenth = 0; eapLenth <= 6; eapLenth++) {
				    for (eapData = 1; eapData <= 3; eapData++) {
				    	for (eapType = 1; eapType <= 9; eapType++) {
					    	for (eapState = 1; eapState <= 2; eapState++) {
					    		result = sendPacketsSequence(eapCode,eapId,eapLenth,eapData,eapType,eapState);
					    		if(result > 1) {
					    			clientSocket.close();
					    			DebugInfo.printMessage(1,"socket closed, stop test");
					    			return;
					    		}
					    	}
				    	}
				    }
			    }
		    }
	    }

	    for (eapId = 1; eapId <= 2; eapId++) {
		    for (eapLenth = 0; eapLenth <= 6; eapLenth++) {
			    for (eapData = 1; eapData <= 3; eapData++) {
			    	for (eapType = 1; eapType <= 9; eapType++) {
				    	for (eapState = 1; eapState <= 2; eapState++) {
				    		result = sendPacketsSequence2(7,eapId,eapLenth,eapData,eapType,eapState);
				    		if(result > 1) {
				    			clientSocket.close();
				    			DebugInfo.printMessage(1,"socket closed, stop test");
				    			return;
				    		}
				    	}
			    	}
			    }
		    }
	    }
	    
		DebugInfo.printMessage(1,"run: number of received packets: on wrong " + counterWrongPackets1 + ", on terminate " + counterWrongPackets2);
		counterWrongPackets1 = 0; counterWrongPackets2 = 0;
	

// close socket		
		clientSocket.close();
		DebugInfo.printMessage(1,"socket closed");
	}


	
	int sendPacketsSequence(int eapCode, int eapId, int eapLenth, int eapData, int eapType, int eapState) {
		int res = 0;
		
		// send right init packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create right packet " + numberSendRightPkts++);
		res = sendInitEAPpacket();

		if(receivedEAPPkt != null) {
			DebugInfo.printMessage(1,"sendPacketsSequence: try create second packet");
			try {
				eapSecondMsg = new EAPpldResponse(receivedEAPPkt.identifier, EAPtype.EAP_TYPE_PEAP);
				eapSecondMsg.EAPmethodPld = new EAPtypePldPEAP();
				eapSecondMsg.toByteArray();
				radAttr_eap_second = new EAPRadiusAttributes(79,eapSecondMsg.net_msg);
				radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));

			} catch (Exception err) {
				DebugInfo.printMessage(1,"!!! ERROR, sendPacketsSequence: create EAP packet2: " + err);
				return 2;
			}
			
		}
		
		// send wrong packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create wrong packet " + numberSendWrongPkts++);
		DebugInfo.printMessage(1,"sendPacketsSequence: eapCode, eapId, eapLenth, eapData, eapType, eapState: " + eapCode + ", " + eapId + ", " + eapLenth + ", " + eapData + ", " + eapType + ", " + eapState);

		EAPheader eapMsgWrn;
		
		if(eapCode > 5) {
			eapMsgWrn = new EAPpldBasic();
			((EAPpldBasic)eapMsgWrn).type = getTypeByTestID(eapType);
			((EAPpldBasic)eapMsgWrn).EAPmethodPld = getPldDataByEAPType(eapData,((EAPpldBasic)eapMsgWrn).type);
		}
		else {
			eapMsgWrn = new EAPheader();
			if(eapData == 2) {
				eapMsgWrn.pldData = new byte[testRandomData.length];
				System.arraycopy(testRandomData, 0, eapMsgWrn.pldData, 0, testRandomData.length);			}
		}

		if(eapId == 1)
			eapMsgWrn.identifier = (byte)(++counterEAPPkt);
		else
			eapMsgWrn.identifier = eapSecondMsg.identifier;
		
		eapMsgWrn.code = getCodeByTestID(eapCode);
        eapMsgWrn.toByteArray();
        setEAPlengthByTestID(eapLenth, eapMsgWrn.net_msg);
		EAPRadiusAttributes radAttr_eap_wrong = new EAPRadiusAttributes(79,eapMsgWrn.net_msg);
        
		radiusPkt.ReInit(1,counterRadiusPkt++);
		radiusPkt.addAttribute(radAttr_name);
		if((eapState == 2) && (radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendPacketsSequence: State Attribute add to wrong packet");
			radiusPkt.addAttribute(radAttr_state);
		}
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap_wrong);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		sendPacket();
		
		try {
			clientSocket.receive(receivePacket);
			counterWrongPackets1++;
			DebugInfo.printMessage(1,"sendPacketsSequence: packet1 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((res != 0)||(receivedRadPkt.code != 3)||(receivedRadPkt.length != 20)) {
				DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
//				sendTerminatePacket();
//				return res;
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet1: " + err);
		}
		
		
		// send right second packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create right packet " + numberSendRightPkts++);
		res = sendEAPpacket();

		return res;	
	}

	
	int sendPacketsSequence2(int eapCode, int eapId, int eapLenth, int eapData, int eapType, int eapState) {
		int res = 0;
		
		// send right init packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create right packet " + numberSendRightPkts++);
		res = sendInitEAPpacket();

		if(receivedEAPPkt != null) {
			DebugInfo.printMessage(1,"sendPacketsSequence: try create second packet");
			try {
				eapSecondMsg = new EAPpldResponse(receivedEAPPkt.identifier, EAPtype.EAP_TYPE_PEAP);
				eapSecondMsg.EAPmethodPld = new EAPtypePldPEAP();
				eapSecondMsg.toByteArray();
				radAttr_eap_second = new EAPRadiusAttributes(79,eapSecondMsg.net_msg);
				radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));

			} catch (Exception err) {
				DebugInfo.printMessage(1,"!!! ERROR, sendPacketsSequence: create EAP packet2: " + err);
				return 2;
			}
			
		}
		
		// send wrong packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create wrong packet " + numberSendWrongPkts++);
		DebugInfo.printMessage(1,"sendPacketsSequence: eapCode, eapId, eapLenth, eapData, eapType, eapState: " + eapCode + ", " + eapId + ", " + eapLenth + ", " + eapData + ", " + eapType + ", " + eapState);

		EAPpldBasic eapMsgWrn = new EAPpldBasic();
		eapMsgWrn.type = EAPtype.EAP_TYPE_EXPANDED_TYPES;
		eapMsgWrn.EAPmethodPld = getExpandedDataByEAPType(eapData,eapType);
		
		if(eapId == 1)
			eapMsgWrn.identifier = (byte)(++counterEAPPkt);
		else
			eapMsgWrn.identifier = eapSecondMsg.identifier;
		
		eapMsgWrn.code = getCodeByTestID(eapCode);
        eapMsgWrn.toByteArray();
        setEAPlengthByTestID(eapLenth, eapMsgWrn.net_msg);
		EAPRadiusAttributes radAttr_eap_wrong = new EAPRadiusAttributes(79,eapMsgWrn.net_msg);
        
		radiusPkt.ReInit(1,counterRadiusPkt++);
		radiusPkt.addAttribute(radAttr_name);
		if((eapState == 2) && (radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendPacketsSequence: State Attribute add to wrong packet");
			radiusPkt.addAttribute(radAttr_state);
		}
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap_wrong);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		sendPacket();
		
		try {
			clientSocket.receive(receivePacket);
			counterWrongPackets1++;
			DebugInfo.printMessage(1,"sendPacketsSequence: packet1 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((res != 0)||(receivedRadPkt.code != 3)) {
				DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
				sendTerminatePacket();
				return res;
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet1: " + err);
		}
		
		
		// send right second packet
		DebugInfo.printMessage(1,"sendPacketsSequence: try create right packet " + numberSendRightPkts++);
		res = sendEAPpacket();

		return res;	
	}

	
	int parseRecvMessage() {
		int res1, res2 = 0;
		
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "received packet");

		// parse received message
		receivedRadPkt = new EAPRadiusHeader();
		receivedRadPkt.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, receivedRadPkt.net_msg, 0, receivePacket.getLength());
		res1 = receivedRadPkt.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		receivedRadPkt.print();
		if(radiusPkt.identifier != receivedRadPkt.identifier) {
			DebugInfo.printMessage(1,"!!! Warning: received identifier not equal sended one");
			res1 += 2;
		}

		// parse EAP received message
		receivedEAPPkt = null;
		EAPRadiusAttributes eapRadAttr = receivedRadPkt.getAttributeByType(79);
		if((eapRadAttr != null) && (eapRadAttr.value != null)) {
			DebugInfo.printMessage(1,"EAP message found, try parse");
			if(eapRadAttr.value.length > 4)
				receivedEAPPkt = new EAPpldBasic();
			else
				receivedEAPPkt = new EAPheader();
			
			receivedEAPPkt.net_msg = new byte[eapRadAttr.value.length];
			System.arraycopy(eapRadAttr.value, 0, receivedEAPPkt.net_msg, 0, eapRadAttr.value.length);
			res2 = receivedEAPPkt.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res2);
			receivedEAPPkt.print("   ");
		}
		
		return (res1 + res2);
	}
	

	int sendInitEAPpacket() {
		int res = 0;
		
		if(radAttr_eap_init.net_msg != null)
			radAttr_eap_init.net_msg[3] = (byte)(counterEAPPkt++); // change EAP 'identifier' field
		
		radiusPkt.ReInit(1,counterRadiusPkt++);
		radiusPkt.addAttribute(radAttr_name);
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap_init);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		sendPacket();

		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendPacketsSequence: packet2 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if(receivedEAPPkt == null)
				res = 2;
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet2: " + err);
			DebugInfo.printMessage(1,"!!! ERROR: sendPacketsSequence: not receive answer");
			res = 2;
		}
		
		return res;
	}

	int sendEAPpacket() {
		int res = 0;
		
		radiusPkt.ReInit(1,counterRadiusPkt++);
		radiusPkt.addAttribute(radAttr_name);
		if((radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendEAPpacket: State Attribute found");
			radiusPkt.addAttribute(radAttr_state);
		}
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap_second);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		sendPacket();

		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendEAPpacket: packet2 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((receivedEAPPkt == null)||(receivedEAPPkt.code != EAPcode.EAP_CODE_SUCCESS)||
				(receivedRadPkt.code != RadiusCode.RADIUS_CODE_ACCESS_ACCEPT.getValue())) {
				DebugInfo.printMessage(1,"!!! ERROR: sendEAPpacket: received unexpected answer");
//				res = 2;
//				sendTerminatePacket();
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendEAPpacket: receive packet2: " + err);
			DebugInfo.printMessage(1,"!!! ERROR: sendEAPpacket: not receive answer");
			res = 2;
		}
		
		return res;
	}

	int sendTerminatePacket() {
		DebugInfo.printMessage(1,"sendTerminatePacket: try send terminate packet");
		EAPRadiusAttributes stateRadiusAttr = receivedRadPkt.getAttributeByType(24);
		if((stateRadiusAttr != null) && (stateRadiusAttr.value != null)) {
			DebugInfo.printMessage(1,"sendTerminatePacket: State Attribute found");
			radiusPkt.ReInit(1,counterRadiusPkt++);
			radiusPkt.addAttribute(stateRadiusAttr);
			radiusPkt.addAttribute(radAttr_auth);
			radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
			radiusPkt.toByteArray();
			sendPacket();
			try {
				clientSocket.receive(receivePacket);
				DebugInfo.printMessage(1,"sendTerminatePacket: packet has been received, length: " + receivePacket.getLength());
				counterWrongPackets2++;
				parseRecvMessage();
				if(receivedRadPkt.code != 3) 
					DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
			} catch (IOException err) {
				DebugInfo.printMessage(1,"sendTerminatePacket: receive packet: " + err);
			}
		}
		
		return 0;
	}
	

	void sendPacket() {
		DebugInfo.printDump(2, radiusPkt.net_msg, "sendPacket: Radius packet");
		DebugInfo.printMessage(1,"sendPacket: Sending Radius packet");
		sendPacket = new DatagramPacket(radiusPkt.net_msg, radiusPkt.net_msg.length, remoteIPAddress, destination_port);
		radiusPkt.isLengthSet = false;
		try {
			clientSocket.send(sendPacket);
		} catch (IOException err) {
			DebugInfo.printMessage(1,"!!!ERROR, sendPacket: send packet: " + err);
		}
		DebugInfo.printMessage(1,"sendPacket: packet has been sended");
	}
	

	EAPcode getCodeByTestID(int counter) {
		switch (counter) {
		case 1: return EAPcode.EAP_CODE_ZERO;
		case 2: return EAPcode.EAP_CODE_UNKNOWN;
		case 3:	return EAPcode.EAP_CODE_SUCCESS;
		case 4:	return EAPcode.EAP_CODE_FAILURE;
		case 5: return EAPcode.EAP_CODE_TEST;
		case 6: return EAPcode.EAP_CODE_REQUEST;
		case 7:	return EAPcode.EAP_CODE_RESPONSE;
		default: return EAPcode.EAP_CODE_UNKNOWN;
		}
	}
	
	
	EAPtype getTypeByTestID(int counter) {
		switch (counter) {
		case 1: return EAPtype.EAP_TYPE_UNKNOWN;
		case 2: return EAPtype.EAP_TYPE_NOTIFICATION;
		case 3:	return EAPtype.EAP_TYPE_TEST;
		case 4:	return EAPtype.EAP_TYPE_EXPERIMENTAL;
		case 5:	return EAPtype.EAP_TYPE_IDENTITY;
		case 6:	return EAPtype.EAP_TYPE_EXPANDED_TYPES;
		case 7:	return EAPtype.EAP_TYPE_NAK;
		case 8:	return EAPtype.EAP_TYPE_MD5CHALLENGE;
		case 9:	return EAPtype.EAP_TYPE_PEAP;
		default: return EAPtype.EAP_TYPE_UNKNOWN;
		}
	}

	
	BasicPayloadObject getPldDataByEAPType(int data, EAPtype tp) {
		BasicPayloadObject pld = null;
		
		if(data == 2) {
			pld = new EAPtypePldID(testRandomData);
		} else if(data == 3) {
			switch (tp) {
			case EAP_TYPE_IDENTITY: pld = new EAPtypePldID(userName.getBytes()); break;
			case EAP_TYPE_NAK:	
				byte[] b1 = {0};
				pld = new EAPtypePldID(b1);
				break;
			case EAP_TYPE_EXPANDED_TYPES: pld = new EAPtypePldID(testRandomExpandedData);  break;
			case EAP_TYPE_MD5CHALLENGE:	pld = new EAPtypePldID(eapSecondMsg.EAPmethodPld.net_msg);  break;
			case EAP_TYPE_PEAP:	pld = new EAPtypePldPEAP();  break;
			}
		}
		return pld;
	}

	
	void setEAPlengthByTestID(int counter, byte[] eapByteMsg) {
		switch (counter) {
		case 0:	eapByteMsg[2]=0; eapByteMsg[3]=5; break;
		case 1:	eapByteMsg[2]=0; eapByteMsg[3]=0; break;
		case 2:	eapByteMsg[2]=0; eapByteMsg[3]=2; break;
		case 3:	eapByteMsg[2]=0; eapByteMsg[3]=4; break;
		case 4:	eapByteMsg[2]=0; eapByteMsg[3]-=1; break;
		case 5:	eapByteMsg[2]=0; eapByteMsg[3]+=3; break;
		}
	}

	
	BasicPayloadObject getExpandedDataByEAPType(int data, int tp) {
		BasicPayloadObject pld = null;

		EAPtype etype = getTypeByTestID(tp);
		byte[] expData;
		byte[] expPld;
		
		if(data == 2) {
			expData = testRandomData;
		} else if(data == 3) {
			switch (etype) {
			case EAP_TYPE_IDENTITY: expData = userName.getBytes(); break;
			case EAP_TYPE_NAK: expData = testExpandedNak; break;
			case EAP_TYPE_MD5CHALLENGE:	expData = eapSecondMsg.EAPmethodPld.net_msg;  break;
			case EAP_TYPE_PEAP:	expData = eapSecondMsg.EAPmethodPld.net_msg;  break;
			case EAP_TYPE_EXPANDED_TYPES:
				byte[] tmpdata = userName.getBytes();
				expData = new byte[testExpandedData.length + tmpdata.length];
				System.arraycopy(testExpandedData, 0, expData, 0, testExpandedData.length);
				System.arraycopy(tmpdata, 0, expData, testExpandedData.length, tmpdata.length);
				break;
			default: expData = testRandomData;
			}
		} else {
			expData = new byte[0];
		}

		expPld = new byte[7 + expData.length];
		int j;
		for(j=0;j<6;j++)
			expPld[j] = 0;
		expPld[j++] = (byte)(etype.getValue());
		if(expData.length > 0)
			System.arraycopy(expData, 0, expPld, j, expData.length);

		pld = new EAPtypePldID(expPld);
		return pld;
	}
	
	
	public static int ntohs(byte[] x, int pos)
	{
		int res = 0;
		if(x.length >= 2) {
				res = x[pos++] & 0xFF;
				res <<= 8;
				res |= (x[pos] & 0xFF);
		}
		return res;
	}

}

