
// test EAPSIM first message

package ru.ispras.telecomtesk.eap;

import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import javax.crypto.interfaces.DHPublicKey;

import ru.ispras.telecomtesk.eap.EAPoverRadius.*;
import ru.ispras.telecomtesk.eap.EAPSIM.*;
import ru.ispras.telecomtesk.eap.EAPSIM.Attributes.*;



public class testEAPSIM4
{
    public static void main(String args[]) throws Exception {
    	testEAPSIM4Run test1 = new testEAPSIM4Run();
    	test1.runtest();
    }
}

class testEAPSIM4Run
{
	public static int destination_port = 1812; 

	public static byte[] sendData = new byte[65000];
	public static int sendDataLength = 0;
	public static byte[] receiveData = new byte[65000];
	public static int receiveDataLength = 0;

	public static InetAddress remoteIPAddress;
//	public static String remoteHost = "192.168.56.101";
	public static byte[] remoteHostRaw = {(byte)(192),(byte)(168),(byte)(56),(byte)(101)};
//	public static byte[] localHostRaw = {(byte)(192),(byte)(168),(byte)(160),(byte)(1)};
	public static byte[] localHostRaw = {(byte)(127),(byte)(0),(byte)(0),(byte)(1)};

	DatagramSocket clientSocket;
	DatagramPacket sendPacket;
	DatagramPacket receivePacket;

	byte[] SharedSecret;
	byte[] UserPwd;
	String userName = "eapsimtest";
	String SharedSecretStr = "testing123";
	String UserPwdStr = "123456";

	int numberSendWrongPkts = 1;
	int numberSendRightPkts = 1;

	int counterRadiusPkt = 1;
	int counterEAPPkt = 1;
	EAPRadiusHeader radiusPkt;
	EAPRadiusAttributes radAttr_name;
	EAPRadiusAttributes radAttr_auth;

	EAPRadiusHeader	receivedRadPkt;
	EAPheader receivedEAPPkt;
    
	EAPpldBasic eapInitMsg;
	EAPRadiusAttributes radAttr_eap_init;
	EAPpldBasic eapSecondMsg;
	EAPpldBasic eapThirdMsg;
	EAPRadiusAttributes radAttr_eap_second;
	EAPRadiusAttributes radAttr_eap_third;
	EAPRadiusAttributes radAttr_state;

	int counterWrongPackets1 = 0;
	int counterWrongPackets2 = 0;
    
	byte[] testRandomData = {1,2,3,4,5,6,7,8};
	byte[] testRandomMD5Data = {16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	byte[] testRandomExpandedData = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
	byte[] testExpandedNak = {(byte)254,0,0,0,0,0,0,4,(byte)254,0,0,0,0,0,0,0};
	byte[] testExpandedData = {0,0,0,0,0,0,(byte)254,0,0,0,0,0,0,1};

	static byte[] localRand1 = {(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34};
	static byte[] localRand2 = {0x20,0x01,0x00,0x00,0x05,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand3 = {(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a};
	static byte[] localRand4 = {0x20,0x01,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand5 = {(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab};
	static byte[] localKc1 = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
	static byte[] localKc2 = {0x30,0x01,0x00,0x00,0x00,0x00,0x00,0x52};
	static byte[] localKc3 = {0x10,0x21,0x32,0x43,0x54,0x65,0x76,(byte)0x87};
	static byte[] localKc4 = {0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localKc5 = {0x30,0x41,0x52,0x63,0x74,(byte)0x85,(byte)0x96,(byte)0xa7};
	static byte[] localSres1 = {0x12,0x34,(byte)0xab,(byte)0xcd};
	static byte[] localSres2 = {0x23,0x43,0x13,0x11};
	static byte[] localSres3 = {0x23,0x4a,(byte)0xbc,(byte)0xd1};
	static byte[] localSres4 = {0x33,0x33,0x13,0x11};
	static byte[] localSres5 = {0x34,(byte)0xab,(byte)0xcd,0x12};
	EAPsimTriplets localTriplets = new EAPsimTriplets();
    EAPsimGSMtriplet gsmTrpl1 = new EAPsimGSMtriplet(localRand1,localKc1,localSres1);
    EAPsimGSMtriplet gsmTrpl2 = new EAPsimGSMtriplet(localRand2,localKc2,localSres2);
    EAPsimGSMtriplet gsmTrpl3 = new EAPsimGSMtriplet(localRand3,localKc3,localSres3);
    EAPsimGSMtriplet gsmTrpl4 = new EAPsimGSMtriplet(localRand4,localKc4,localSres4);
    EAPsimGSMtriplet gsmTrpl5 = new EAPsimGSMtriplet(localRand5,localKc5,localSres5);

	TestAttributesSequence4 tstAttrLst = null;
	EAPtypePldSim eapSim = null;
	EAPtypePldSim eapSim2 = null;
	byte[] masterKey = null;
	EAPsimAttrVersionList recvVerList = null;
	EAPsimAttrRand recvRand = null;
    EAPsimAttrMAC recvMAC = null;
    int recvMacPosition = 0;

	public void runtest() throws Exception {
		DebugInfo.debugLevel = 2;
		DebugInfo.maxDumpSize = 1000;

		clientSocket = new DatagramSocket();
		clientSocket.setSoTimeout(3000);
		remoteIPAddress = InetAddress.getByAddress(remoteHostRaw);
		receivePacket = new DatagramPacket(receiveData, receiveData.length);

		SharedSecret = SharedSecretStr.getBytes();
		UserPwd = UserPwdStr.getBytes();

		radiusPkt = new EAPRadiusHeader(1,counterRadiusPkt);
		
	    radAttr_name = new EAPRadiusAttributes(1);
		radAttr_name.value = userName.getBytes();

	    radAttr_auth = new EAPRadiusAttributes(80);
		
	    eapInitMsg = new EAPpldResponse(counterEAPPkt++, EAPtype.EAP_TYPE_IDENTITY);
	    eapInitMsg.EAPmethodPld = new EAPtypePldID(userName.getBytes());
	    eapInitMsg.toByteArray();
		radAttr_eap_init = new EAPRadiusAttributes(79,eapInitMsg.net_msg);

		tstAttrLst = new TestAttributesSequence4();
		eapSim = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_START);
		eapSim2 = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_CHALLENGE);
		
        localTriplets.addTriplet(gsmTrpl1);
        localTriplets.addTriplet(gsmTrpl2);
        localTriplets.addTriplet(gsmTrpl3);
        localTriplets.addTriplet(gsmTrpl4);
        localTriplets.addTriplet(gsmTrpl5);
		
		int eapSimInd;
		int eapSimAttrInd;
		int result;

		setSecondEAPpkt(eapSim);

		for (eapSimAttrInd = 1; eapSimAttrInd <= tstAttrLst.numberTests[0]; eapSimAttrInd++) {
			DebugInfo.printMessage(1,"eapSimAttrInd: " + eapSimAttrInd);
	    		result = sendPacketsSequence(eapSimAttrInd);
	    		if(result > 1) {
	    			clientSocket.close();
	    			DebugInfo.printMessage(1,"socket closed, stop test");
	    			return;
			    }
		    }
		
		DebugInfo.printMessage(1,"run: number of received packets: on wrong " + counterWrongPackets1 + ", on terminate " + counterWrongPackets2);
		counterWrongPackets1 = 0; counterWrongPackets2 = 0;
	

		// close socket		
		clientSocket.close();
		DebugInfo.printMessage(1,"socket closed");
	}

	public void setSecondEAPpkt(EAPtypePldSim eapSim) {
		DebugInfo.printMessage(1,"setSecondEAPpkt");

		if(eapSim != null) {
			EAPsimAttrNonceMT attrNonceMT = new EAPsimAttrNonceMT();
			EAPsimAttrIdentity attrID = new EAPsimAttrIdentity(userName.getBytes());
			EAPsimAttrSelectedVersion attrSelVer = new EAPsimAttrSelectedVersion(1);

			eapSim.clearAttributesList();
			
			eapSim.addAttribute(attrID);
			eapSim.addAttribute(attrNonceMT);
			eapSim.addAttribute(attrSelVer);

		} else {
			DebugInfo.printMessage(1,"!!! ERROR: setSecondEAPpkt: null pointer");
		}
	}

	
	int sendPacketsSequence(int eapSimAttrInd) {
		int res = 0;
		EAPtypePldSim receivedEAPsim;
		
		// send init ID packet
		DebugInfo.printMessage(1,"\n================================================");
		DebugInfo.printMessage(1,"sendPacketsSequence: try create init ID packet " + numberSendRightPkts++);
		res = sendInitEAPpacket();

                // create second packet
		if(receivedEAPPkt != null) {
			try {
				eapSecondMsg = new EAPpldResponse(receivedEAPPkt.identifier, EAPtype.EAP_TYPE_SIM);
				radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));
			} catch (Exception err) {
				DebugInfo.printMessage(1,"!!! ERROR, sendPacketsSequence: create EAP packet2: " + err);
				return 2;
			}
			
	        if(receivedEAPPkt instanceof EAPpldBasic) {
	        	EAPtype eapType =((EAPpldBasic)receivedEAPPkt).type;
	        	if(eapType == EAPtype.EAP_TYPE_SIM) {
	        		receivedEAPsim = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
	                recvVerList = 
	                	(EAPsimAttrVersionList)(receivedEAPsim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_VERSION_LIST));
	           } else {
	    			DebugInfo.printMessage(1,"recieved unexpected message (wait EAPSIM)");
	    			return 3;
	            }
	        } else {
				DebugInfo.printMessage(1,"recieved unexpected message");
				return 3;
	        }
		}
		
		// send second packet
		DebugInfo.printMessage(1,"-------------------------------");
		DebugInfo.printMessage(1,"sendPacketsSequence: try create second packet " + numberSendWrongPkts++);

		eapSecondMsg.EAPmethodPld = eapSim;
		eapSecondMsg.toByteArray();
		radAttr_eap_second = new EAPRadiusAttributes(79,eapSecondMsg.net_msg);
		
		DebugInfo.printMessage(1,"sendPacketsSequence: try send second packet");
		res = sendEAPpacket(radAttr_eap_second, eapSecondMsg);

                // create third packet
		if(receivedEAPPkt != null) {
			try {
				eapThirdMsg = new EAPpldResponse(receivedEAPPkt.identifier, EAPtype.EAP_TYPE_SIM);
				radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));
			} catch (Exception err) {
				DebugInfo.printMessage(1,"!!! ERROR, sendPacketsSequence: create EAP packet3: " + err);
				return 2;
			}
			
       		if(receivedEAPPkt instanceof EAPpldBasic) {
       			EAPtype eapType =((EAPpldBasic)receivedEAPPkt).type;
       			if(eapType == EAPtype.EAP_TYPE_SIM) {
          			receivedEAPsim = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
           			recvMacPosition = receivedEAPsim.parsedMACposition;
           			recvRand = (EAPsimAttrRand)(receivedEAPsim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_RAND));
                	recvMAC = (EAPsimAttrMAC)(receivedEAPsim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_MAC));
       			} else {
    				DebugInfo.printMessage(1,"recieved unexpected message (wait EAPSIM)");
    				return 3;
            	}
        	} else {
				DebugInfo.printMessage(1,"recieved unexpected message");
				return 4;
        	}
        } else {
			DebugInfo.printMessage(1,"recieved no message");
			return 5;
        }

       	EAPsimTriplets curtrpl = localTriplets.getTripletByRand(recvRand.attrData);

       	byte[] nKcKEY = curtrpl.combineAllKc();
       	byte[] nSresKEY = curtrpl.combineAllSres();

       	EAPsimAttrIdentity sendAttrID = (EAPsimAttrIdentity)(eapSim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_IDENTITY));
       	EAPsimAttrNonceMT sendAttrNonceMT = (EAPsimAttrNonceMT)(eapSim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_NONCE_MT));
       	EAPsimAttrSelectedVersion sendAttrSelVer = (EAPsimAttrSelectedVersion)(eapSim.getAttributeByType(EAPsimAttrType.EAPSIM_AT_SELECTED_VERSION));
       	masterKey = EAPsimSecurity.createMasterKey(sendAttrID.value, nKcKEY, sendAttrNonceMT.attrData, recvVerList.versionListToByteArray(), sendAttrSelVer.value);
       	byte[] newKeysArray = EAPsimSecurity.eapSimPRF(masterKey, 160);
       	byte[] newKauth = new byte[16];
       	System.arraycopy(newKeysArray, 16, newKauth, 0, newKauth.length);

       	// check received MAC
       	byte[] dataForMacCalc = new byte[receivedEAPPkt.net_msg.length + sendAttrNonceMT.attrData.length];
       	System.arraycopy(receivedEAPPkt.net_msg, 0, dataForMacCalc, 0, receivedEAPPkt.net_msg.length);
       	for(int j=0; j<16; j++)
       		dataForMacCalc[recvMacPosition + j] = 0;
       	System.arraycopy(sendAttrNonceMT.attrData, 0, dataForMacCalc, receivedEAPPkt.net_msg.length, sendAttrNonceMT.attrData.length);
       	byte[] calcMAC = EAPsimSecurity.mac(dataForMacCalc, newKauth);
       	EAPsimSecurity.compareMac(recvMAC.attrData, calcMAC);
        	
		eapThirdMsg.EAPmethodPld = eapSim2;
		eapSim2.clearAttributesList();
		EAPsimAttrMAC macSend = new EAPsimAttrMAC();
		eapSim2.addAttribute(macSend);

		if(eapSimAttrInd <= 4)
    		tstAttrLst.setAttrMAC(eapSimAttrInd, macSend);

       	eapThirdMsg.toByteArray();

       	// calculate sending MAC
       	dataForMacCalc = new byte[eapThirdMsg.net_msg.length + nSresKEY.length];
       	System.arraycopy(eapThirdMsg.net_msg, 0, dataForMacCalc, 0, eapThirdMsg.net_msg.length);
       	System.arraycopy(nSresKEY, 0, dataForMacCalc, eapThirdMsg.net_msg.length, nSresKEY.length);
       	if(eapSimAttrInd != 8)
       		macSend.attrData = EAPsimSecurity.mac(dataForMacCalc, newKauth);
       	else
       		macSend.attrData = EAPsimSecurity.macSHA1(dataForMacCalc, newKauth);
        	
       	if(eapSimAttrInd >= 5)
       		tstAttrLst.setAttrMAC(eapSimAttrInd, macSend);
        
       	macSend.toByteArray();

		// send third packet
		DebugInfo.printMessage(1,"-------------------------------");
		DebugInfo.printMessage(1,"sendPacketsSequence: try create secod packet " + numberSendWrongPkts++);

		eapThirdMsg.toByteArray();
		radAttr_eap_third = new EAPRadiusAttributes(79,eapThirdMsg.net_msg);
		
		DebugInfo.printMessage(1,"sendPacketsSequence: try send third packet");
		res = sendEAPpacket(radAttr_eap_third, eapThirdMsg);

		return res;	
	}
	

	int parseRecvMessage() {
		int res1, res2 = 0;
		
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "received packet");

		// parse received message
		receivedRadPkt = new EAPRadiusHeader();
		receivedRadPkt.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, receivedRadPkt.net_msg, 0, receivePacket.getLength());
		res1 = receivedRadPkt.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		receivedRadPkt.print();
		if(radiusPkt.identifier != receivedRadPkt.identifier) {
			DebugInfo.printMessage(1,"!!! Warning: received identifier not equal sended one");
			res1 += 2;
		}

		// parse EAP received message
		receivedEAPPkt = null;
		EAPRadiusAttributes eapRadAttr = receivedRadPkt.getAttributeByType(79);
		if((eapRadAttr != null) && (eapRadAttr.value != null)) {
			DebugInfo.printMessage(1,"EAP message found, try parse");
			if(eapRadAttr.value.length > 4)
				receivedEAPPkt = new EAPpldBasic();
			else
				receivedEAPPkt = new EAPheader();
			
			receivedEAPPkt.net_msg = new byte[eapRadAttr.value.length];
			System.arraycopy(eapRadAttr.value, 0, receivedEAPPkt.net_msg, 0, eapRadAttr.value.length);
			res2 = receivedEAPPkt.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res2);
			receivedEAPPkt.print("   ");
		}
		
		return (res1 + res2);
	}
	

	int sendInitEAPpacket() {
		int res = 0;
		
		if(radAttr_eap_init.net_msg != null)
			radAttr_eap_init.net_msg[3] = (byte)(counterEAPPkt++); // change EAP 'identifier' field
		
		radiusPkt.ReInit(1,counterRadiusPkt++);
		radiusPkt.addAttribute(radAttr_name);
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap_init);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		sendPacket();

		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendPacketsSequence: packet2 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if(receivedEAPPkt == null)
				res = 2;
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet2: " + err);
			DebugInfo.printMessage(1,"!!! ERROR: sendPacketsSequence: not receive answer");
			res = 2;
		}
		
		return res;
	}

	int sendEAPpacket(EAPRadiusAttributes radAttr_eap, EAPheader eapPkt) {
		int res = 0;
		
		radiusPkt.ReInit(1,counterRadiusPkt++);
//		radiusPkt.addAttribute(radAttr_name);
		if((radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendEAPpacket: State Attribute found");
			radiusPkt.addAttribute(radAttr_state);
		}
		radiusPkt.addAttribute(radAttr_auth);
		radiusPkt.addAttribute(radAttr_eap);

		radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
		radiusPkt.toByteArray();
		
		DebugInfo.printMessage(1,"radius packet for send: ");
		radiusPkt.print();
		
		DebugInfo.printMessage(1,"EAP packet for send: ");
		eapPkt.print("   ");

		sendPacket();

		try {
			clientSocket.receive(receivePacket);
			counterWrongPackets1++;
			DebugInfo.printMessage(1,"sendEAPpacket: packet2 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendEAPpacket: receive packet2: " + err);
			DebugInfo.printMessage(1,"!!! ERROR: sendEAPpacket: not receive answer");
			res = 2;
		}
		
		return res;
	}

	int sendTerminatePacket() {
		DebugInfo.printMessage(1,"sendTerminatePacket: try send terminate packet");
		EAPRadiusAttributes stateRadiusAttr = receivedRadPkt.getAttributeByType(24);
		if((stateRadiusAttr != null) && (stateRadiusAttr.value != null)) {
			DebugInfo.printMessage(1,"sendTerminatePacket: State Attribute found");
			radiusPkt.ReInit(1,counterRadiusPkt++);
			radiusPkt.addAttribute(stateRadiusAttr);
			radiusPkt.addAttribute(radAttr_auth);
			radAttr_auth.setMessageAuthenticator(radiusPkt,SharedSecret);
			radiusPkt.toByteArray();
			sendPacket();
			try {
				clientSocket.receive(receivePacket);
				DebugInfo.printMessage(1,"sendTerminatePacket: packet has been received, length: " + receivePacket.getLength());
				counterWrongPackets2++;
				parseRecvMessage();
				if(receivedRadPkt.code != 3) 
					DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
			} catch (IOException err) {
				DebugInfo.printMessage(1,"sendTerminatePacket: receive packet: " + err);
			}
		}
		
		return 0;
	}
	

	void sendPacket() {
		DebugInfo.printDump(2, radiusPkt.net_msg, "sendPacket: Radius packet");
		DebugInfo.printMessage(1,"sendPacket: Sending Radius packet");
		sendPacket = new DatagramPacket(radiusPkt.net_msg, radiusPkt.net_msg.length, remoteIPAddress, destination_port);
		radiusPkt.isLengthSet = false;
		try {
			clientSocket.send(sendPacket);
		} catch (IOException err) {
			DebugInfo.printMessage(1,"!!!ERROR, sendPacket: send packet: " + err);
		}
		DebugInfo.printMessage(1,"sendPacket: packet has been sended");
	}

}

class TestAttributesSequence4
{
	int numberTestsAttrMAC = 9;
	int[] numberTests = {numberTestsAttrMAC};
    
	TestAttributesSequence4() {}
	    
	public int setAttrMAC(int ind, EAPsimAttrMAC eapSimMac) {
		switch(ind) {
		case 1: eapSimMac.setLength(0); break; // Length = 0
		case 2: eapSimMac.setLength(4); break; // Length < NonceMT
		case 3: eapSimMac.setLength(6); break; // Length > NonceMT
		case 4: eapSimMac.value[0] = 1; // Reserved = random
				eapSimMac.value[1] = 1;
			break; 
		case 5: if(eapSimMac.attrData != null) // change first byte MAC
					eapSimMac.attrData[0] ++;
				break;
		case 6: eapSimMac.attrData = new byte[0]; eapSimMac.setLength(); break; // MAC = null
		case 7: byte[] tmpData = new byte[12]; 
				if(eapSimMac.attrData.length > 12) {
					System.arraycopy(eapSimMac.attrData, 0, tmpData, 0, tmpData.length);
					eapSimMac.attrData = tmpData;
					eapSimMac.setLength(); 
				} 
				break; // MAC = 12 bytes
		case 8: // MAC = 20 bytes called function macSHA1()
		default:  break; 
		}

		return 0;
	}

}

