package ru.ispras.telecomtesk.eap;

import java.io.*;
import java.math.BigInteger;
import java.net.*;
import java.util.ArrayList;
import java.security.*;

import javax.crypto.interfaces.DHPublicKey;
import javax.xml.bind.DatatypeConverter;

import ru.ispras.telecomtesk.eap.EAPoverRadius.*;
import ru.ispras.telecomtesk.eap.EAPSIM.*;
import ru.ispras.telecomtesk.eap.EAPSIM.Attributes.*;



public class tryEAPSIMinit
{
    public static void main(String args[]) throws Exception {
    	tryEAPSIMinitRun test1 = new tryEAPSIMinitRun();
    	test1.runtest();
    }
}

class tryEAPSIMinitRun
{
	// for messages that don't belong to any IKE_SA
	public ArrayList request_list_noSA;
	public ArrayList response_list_noSA;
	// messages received from NUT
	public ArrayList received_messages_list;
	public static int MTN_ike2_window_size;
	public static int destination_port = 1812; 

	public static byte[] sendData = new byte[65000];
	public static int sendDataLength = 0;
	public static byte[] receiveData = new byte[65000];
	public static int receiveDataLength = 0;

	public static InetAddress remoteIPAddress;
//	public static String remoteHost = "192.168.56.101";
	public static byte[] remoteHostRaw = {(byte)(10),(byte)(10),(byte)(12),(byte)(12)};
//	public static byte[] remoteHostRaw = {(byte)(192),(byte)(168),(byte)(56),(byte)(101)};
//	public static byte[] localHostRaw = {(byte)(192),(byte)(168),(byte)(160),(byte)(1)};
//	public static byte[] remoteHostRaw = {(byte)(127),(byte)(0),(byte)(0),(byte)(1)};
	public static byte[] localHostRaw = {(byte)(127),(byte)(0),(byte)(0),(byte)(1)};

	EAPRadiusHeader	receivedRadPkt;
	EAPheader receivedEAPPkt;
	DatagramPacket receivePacket;
	EAPRadiusAttributes radAttr_state;

	static byte[] localRand1 = {(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34};
	static byte[] localRand2 = {0x20,0x01,0x00,0x00,0x05,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand3 = {(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a,(byte)0xbc,(byte)0xd1,0x23,0x4a};
	static byte[] localRand4 = {0x20,0x01,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x42};
	static byte[] localRand5 = {(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab,(byte)0xcd,0x12,0x34,(byte)0xab};
	static byte[] localKc1 = {0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77};
	static byte[] localKc2 = {0x30,0x01,0x00,0x00,0x00,0x00,0x00,0x52};
	static byte[] localKc3 = {0x10,0x21,0x32,0x43,0x54,0x65,0x76,(byte)0x87};
	static byte[] localKc4 = {0x20,0x01,0x00,0x00,0x00,0x00,0x00,0x42};
	static byte[] localKc5 = {0x30,0x41,0x52,0x63,0x74,(byte)0x85,(byte)0x96,(byte)0xa7};
	static byte[] localSres1 = {0x12,0x34,(byte)0xab,(byte)0xcd};
	static byte[] localSres2 = {0x23,0x43,0x13,0x11};
	static byte[] localSres3 = {0x23,0x4a,(byte)0xbc,(byte)0xd1};
	static byte[] localSres4 = {0x33,0x33,0x13,0x11};
	static byte[] localSres5 = {0x34,(byte)0xab,(byte)0xcd,0x12};
	EAPsimTriplets localTriplets = new EAPsimTriplets();
        EAPsimGSMtriplet gsmTrpl1 = new EAPsimGSMtriplet(localRand1,localKc1,localSres1);
        EAPsimGSMtriplet gsmTrpl2 = new EAPsimGSMtriplet(localRand2,localKc2,localSres2);
        EAPsimGSMtriplet gsmTrpl3 = new EAPsimGSMtriplet(localRand3,localKc3,localSres3);
        EAPsimGSMtriplet gsmTrpl4 = new EAPsimGSMtriplet(localRand4,localKc4,localSres4);
        EAPsimGSMtriplet gsmTrpl5 = new EAPsimGSMtriplet(localRand5,localKc5,localSres5);

	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 6;
		DebugInfo.maxDumpSize = 1000;

		DatagramSocket clientSocket = new DatagramSocket();
		clientSocket.setSoTimeout(2000);
//		remoteIPAddress = InetAddress.getByName(remoteHost);
		remoteIPAddress = InetAddress.getByAddress(remoteHostRaw);
		DatagramPacket sendPacket;
		receivePacket = new DatagramPacket(receiveData, receiveData.length);

		String SharedSecretStr = "testing123";
//		String SharedSecretStr = "secret";
		byte[] SharedSecret = SharedSecretStr.getBytes();
		String UserPwdStr = "123456";
//		String UserPwdStr = "efqcltpm+>y]";
		byte[] UserPwd = UserPwdStr.getBytes();
		byte[] ReqAuth1 = {(byte)0x04,(byte)0x82,(byte)0x9f,(byte)0x5e,(byte)0xe2,(byte)0xa4,(byte)0x65,(byte)0xa7,(byte)0x6c,(byte)0x9b,(byte)0xd9,(byte)0xf3,(byte)0x41,(byte)0x60,(byte)0xd4,(byte)0xc6};
		byte[] ReqAuth2 = {(byte)0x5a,(byte)0x30,(byte)0x7e,(byte)0x5b,(byte)0x40,(byte)0xec,(byte)0xc3,(byte)0x95,(byte)0xcc,(byte)0x69,(byte)0x05,(byte)0x41,(byte)0x67,(byte)0xa8,(byte)0x00,(byte)0x13}; 

        localTriplets.addTriplet(gsmTrpl1);
        localTriplets.addTriplet(gsmTrpl2);
        localTriplets.addTriplet(gsmTrpl3);
        localTriplets.addTriplet(gsmTrpl4);
        localTriplets.addTriplet(gsmTrpl5);

        // test section

        
        // send first message		
		DebugInfo.printMessage(1,"try create pkt1");
		
		EAPRadiusHeader	radPkt = new EAPRadiusHeader(1,90);
	
	    EAPRadiusAttributes radAttr_name = new EAPRadiusAttributes(1);
		String userName = "testereapsim"; // eapsimtest
		radAttr_name.value = userName.getBytes();

	    EAPRadiusAttributes radAttr_pwd = new EAPRadiusAttributes(2);
		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);

		byte[] nasHostRaw = {(byte)(127),(byte)(0),(byte)(1),(byte)(1)};
	    EAPRadiusAttributes radAttr_ip = new EAPRadiusAttributes(4,nasHostRaw);

		byte[] nasPortRaw = {(byte)(0),(byte)(0),(byte)(7),(byte)(20)};
	    EAPRadiusAttributes radAttr_port = new EAPRadiusAttributes(5,nasPortRaw);

		EAPRadiusAttributes radAttr_eap_start = new EAPRadiusAttributes(79);

	    EAPRadiusAttributes radAttr_auth = new EAPRadiusAttributes(80);
	    
		int res = 0;
	    int res1;
	    int recvMacPosition = 0;

        EAPpldBasic eapMsgInit = new EAPpldBasic();
        eapMsgInit.code = EAPcode.EAP_CODE_RESPONSE;
        eapMsgInit.identifier = 90;
        eapMsgInit.type = EAPtype.EAP_TYPE_IDENTITY;
        EAPtypePldID eapPldId = new EAPtypePldID(userName.getBytes());
        eapMsgInit.EAPmethodPld = eapPldId;
        eapMsgInit.toByteArray();
		EAPRadiusAttributes radAttr_eap = new EAPRadiusAttributes(79,eapMsgInit.net_msg);
		
		radPkt.addAttribute(radAttr_name);
//        radPkt.addAttribute(radAttr_pwd);
//        radPkt.addAttribute(radAttr_ip);
//        radPkt.addAttribute(radAttr_port);
        radPkt.addAttribute(radAttr_eap);
        radPkt.addAttribute(radAttr_auth);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");


// parse received message		
		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendPacketsSequence: packet1 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((res != 0)||(receivedRadPkt.code != 3)) {
				DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet1: " + err);
		}

		
// send second message		
		radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));
		EAPtypePldSim eapPldSimRecvStart = null;
		EAPsimAttrVersionList recvVerList = null;
		
		EAPpldBasic eapMsg2 = new EAPpldBasic();
        eapMsg2.code = EAPcode.EAP_CODE_RESPONSE;
        eapMsg2.identifier = receivedEAPPkt.identifier;
        eapMsg2.type = EAPtype.EAP_TYPE_SIM;
        if(receivedEAPPkt instanceof EAPpldBasic) {
        	EAPtype eapType =((EAPpldBasic)receivedEAPPkt).type;
        	if(eapType == EAPtype.EAP_TYPE_SIM) {
                eapPldSimRecvStart = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
                recvVerList = 
                	(EAPsimAttrVersionList)(eapPldSimRecvStart.getAttributeByType(EAPsimAttrType.EAPSIM_AT_VERSION_LIST.getValue()));
           } else {
    			DebugInfo.printMessage(1,"recieved unexpected message (wait EAPSIM)");
    			return;
            }
        } else {
			DebugInfo.printMessage(1,"recieved unexpected message");
			return;
        }
        EAPtypePldSim eapPldSimStart = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_START.getValue());
        EAPsimAttrNonceMT nmt = new EAPsimAttrNonceMT();
       	EAPsimAttrSelectedVersion sv = new EAPsimAttrSelectedVersion((short)1);
       	sv.checkValue(recvVerList.versionList);
       	EAPsimAttrIdentity sid = new EAPsimAttrIdentity(userName.getBytes());
       	eapPldSimStart.addAttribute(sid);
       	eapPldSimStart.addAttribute(nmt);
       	eapPldSimStart.addAttribute(sv);
        
        eapMsg2.EAPmethodPld = eapPldSimStart;
        eapMsg2.toByteArray();
		EAPRadiusAttributes radAttr_eap2 = new EAPRadiusAttributes(79,eapMsg2.net_msg);

		radPkt = new EAPRadiusHeader(1,91);
//		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);
        radPkt.addAttribute(radAttr_name);
//        radPkt.addAttribute(radAttr_pwd);
//        radPkt.addAttribute(radAttr_ip);
//        radPkt.addAttribute(radAttr_port);
		if((radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendPacketsSequence: State Attribute add to wrong packet");
			radPkt.addAttribute(radAttr_state);
		}
        radPkt.addAttribute(radAttr_auth);
        radPkt.addAttribute(radAttr_eap2);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");


// parse received message		
		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendPacketsSequence: packet2 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((res != 0)||(receivedRadPkt.code != 3)) {
				DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet2: " + err);
		}
		
		
// send third message		
		DebugInfo.printMessage(1,"try create pkt3");

		radAttr_state = EAPRadiusAttributes.cloneAttribute(receivedRadPkt.getAttributeByType(24));
		EAPtypePldSim eapPldSimRecvClg = null;
		EAPsimAttrRand recvRand = null;
                EAPsimAttrMAC recvMAC = null;
		
		EAPpldBasic eapMsg3 = new EAPpldBasic();
        eapMsg3.code = EAPcode.EAP_CODE_RESPONSE;
        eapMsg3.identifier = receivedEAPPkt.identifier;
        eapMsg3.type = EAPtype.EAP_TYPE_SIM;
        if(receivedEAPPkt instanceof EAPpldBasic) {
        	EAPtype eapType =((EAPpldBasic)receivedEAPPkt).type;
        	if(eapType == EAPtype.EAP_TYPE_SIM) {
                eapPldSimRecvClg = (EAPtypePldSim)(((EAPpldBasic)receivedEAPPkt).EAPmethodPld);
                recvMacPosition = eapPldSimRecvClg.parsedMACposition;
                recvRand = 
                	(EAPsimAttrRand)(eapPldSimRecvClg.getAttributeByType(EAPsimAttrType.EAPSIM_AT_RAND.getValue()));
                recvMAC = 
                	(EAPsimAttrMAC)(eapPldSimRecvClg.getAttributeByType(EAPsimAttrType.EAPSIM_AT_MAC.getValue()));
           } else {
    			DebugInfo.printMessage(1,"recieved unexpected message (wait EAPSIM)");
    			return;
            }
        } else {
			DebugInfo.printMessage(1,"recieved unexpected message");
			return;
        }

        EAPsimTriplets curtrpl = localTriplets.getTripletByRand(recvRand.attrData);

        byte[] nKcKEY = curtrpl.combineAllKc();
        byte[] nSresKEY = curtrpl.combineAllSres();

        DebugInfo.printDump(1, nKcKEY, "nKcKEY:");
        DebugInfo.printDump(1, nSresKEY, "nSresKEY:");
        
       	byte[] newMK = EAPsimSecurity.createMasterKey(sid.value, nKcKEY, nmt.attrData, recvVerList.versionListToByteArray(), sv.value);
        DebugInfo.printDump(1, newMK, "MasterKey:");
		byte[] newKeysArray = EAPsimSecurity.eapSimPRF(newMK, 160);
		DebugInfo.printDump(3, newKeysArray, "newKeysArray:");

		byte[] newKauth = new byte[16];
        System.arraycopy(newKeysArray, 16, newKauth, 0, newKauth.length);

		byte[] recvDataForMac = new byte[receivedEAPPkt.net_msg.length + nmt.attrData.length];
        System.arraycopy(receivedEAPPkt.net_msg, 0, recvDataForMac, 0, receivedEAPPkt.net_msg.length);
        for(int j=0; j<16; j++)
        	recvDataForMac[recvMacPosition + j] = 0;
        System.arraycopy(nmt.attrData, 0, recvDataForMac, receivedEAPPkt.net_msg.length, nmt.attrData.length);
        byte[] calcMAC = EAPsimSecurity.mac(recvDataForMac, newKauth);
        EAPsimSecurity.compareMac(recvMAC.attrData, calcMAC);
		
        EAPtypePldSim eapPldSimClg = new EAPtypePldSim(EAPSIMsubtype.EAPSIM_SUBTYPE_CHALLENGE.getValue());
        EAPsimAttrMAC mac3 = new EAPsimAttrMAC();
       	eapPldSimClg.addAttribute(mac3);
        
		eapMsg3.EAPmethodPld = eapPldSimClg;
        eapMsg3.toByteArray();

        recvDataForMac = new byte[eapMsg3.net_msg.length + nSresKEY.length];
        System.arraycopy(eapMsg3.net_msg, 0, recvDataForMac, 0, eapMsg3.net_msg.length);
        System.arraycopy(nSresKEY, 0, recvDataForMac, eapMsg3.net_msg.length, nSresKEY.length);
        calcMAC = EAPsimSecurity.mac(recvDataForMac, newKauth);
        System.arraycopy(calcMAC, 0, mac3.attrData, 0, calcMAC.length);
        mac3.toByteArray();
        eapMsg3.toByteArray();
        
		EAPRadiusAttributes radAttr_eap3 = new EAPRadiusAttributes(79,eapMsg3.net_msg);

		radPkt = new EAPRadiusHeader(1,92);
//		radAttr_pwd.setUserPassword(UserPwd, SharedSecret, radPkt.authenticator);
        radPkt.addAttribute(radAttr_name);
//        radPkt.addAttribute(radAttr_pwd);
//        radPkt.addAttribute(radAttr_ip);
//        radPkt.addAttribute(radAttr_port);
		if((radAttr_state != null) && (radAttr_state.value != null)) {
			DebugInfo.printMessage(1,"sendPacketsSequence: State Attribute add to wrong packet");
			radPkt.addAttribute(radAttr_state);
		}
        radPkt.addAttribute(radAttr_auth);
        radPkt.addAttribute(radAttr_eap3);

		radAttr_auth.setMessageAuthenticator(radPkt,SharedSecret);
		radPkt.toByteArray();

		DebugInfo.printDump(1, radPkt.net_msg, "Radius packet");
		DebugInfo.printMessage(1,"Sending Radius packet");

		sendPacket = new DatagramPacket(radPkt.net_msg, radPkt.net_msg.length, remoteIPAddress, destination_port);
		clientSocket.send(sendPacket);

		DebugInfo.printMessage(1,"packet has been sended");

// parse received message		
		try {
			clientSocket.receive(receivePacket);
			DebugInfo.printMessage(1,"sendPacketsSequence: packet3 has been received, length: " + receivePacket.getLength());
			res = parseRecvMessage();
			if((res != 0)||(receivedRadPkt.code != 3)) {
				DebugInfo.printMessage(1,"!!! sendPacketsSequence: Received unexpected message");
			}
		} catch (IOException err) {
			DebugInfo.printMessage(1,"sendPacketsSequence: receive packet3: " + err);
		}

// close socket		
		clientSocket.close();
		DebugInfo.printMessage(1,"socket closed");
	}

	
	int parseRecvMessage() {
		int res1, res2 = 0;
		
		DebugInfo.printDump(2, receivePacket.getData(), 0, receivePacket.getLength() , "received packet");

		// parse received message
		receivedRadPkt = new EAPRadiusHeader();
		receivedRadPkt.net_msg = new byte[receivePacket.getLength()];
		System.arraycopy(receivePacket.getData(), 0, receivedRadPkt.net_msg, 0, receivePacket.getLength());
		res1 = receivedRadPkt.parseNetMessage();
		DebugInfo.printMessage(1,"packet was parsed, res: " + res1);
		receivedRadPkt.print();

		// parse EAP received message
		receivedEAPPkt = null;
		EAPRadiusAttributes eapRadAttr = receivedRadPkt.getAttributeByType(79);
		if((eapRadAttr != null) && (eapRadAttr.value != null)) {
			DebugInfo.printMessage(1,"EAP message found, try parse");
			if(eapRadAttr.value.length > 4)
				receivedEAPPkt = new EAPpldBasic();
			else
				receivedEAPPkt = new EAPheader();
			
			receivedEAPPkt.net_msg = new byte[eapRadAttr.value.length];
			System.arraycopy(eapRadAttr.value, 0, receivedEAPPkt.net_msg, 0, eapRadAttr.value.length);
			res2 = receivedEAPPkt.parseNetMessage(); 
			DebugInfo.printMessage(1,"EAP packet was parsed, res: " + res2);
			receivedEAPPkt.print("   ");
		}
		
		return (res1 + res2);
	}

	public static int ntohs(byte[] x, int pos)
	{
		int res = 0;
		if(x.length >= 2) {
				res = x[pos++] & 0xFF;
				res <<= 8;
				res |= (x[pos] & 0xFF);
		}
		return res;
	}

}

