package ru.ispras.telecomtesk.eap;

import ru.ispras.telecomtesk.eap.EAPoverRadius.*;


public class tryEAPnak
{
    public static void main(String args[]) throws Exception {
    	tryEAPnakRun test1 = new tryEAPnakRun();
    	test1.runtest();
    }
}

class tryEAPnakRun
{
//	public static byte[] remoteHostRaw = {(byte)(10),(byte)(10),(byte)(12),(byte)(12)};
	public static byte[] remoteHostRaw = {(byte)(127),(byte)(0),(byte)(0),(byte)(1)};
//	public static byte[] remoteHostRaw = {(byte)(192),(byte)(168),(byte)(56),(byte)(101)};
	public static byte[] localHostRaw = {(byte)(10),(byte)(10),(byte)(9),(byte)(53)};

	EAPRadiusSocket sock = null;
	
	String SharedSecretStr = "testing123";
//	String SharedSecretStr = "secret";
	String userNameStr = "tester";
	String UserPwdStr = "tester";
//	String userNameStr = "user1-radius";
//	String UserPwdStr = "wdcgy159A"; // "123456";
//	String UserPwdStr = "efqcltpm+>y]";

	// 21 0x15 EAP-TTLS; 25 0x19 PEAP; 43 0x2B EAP-FAST; 55 0x37 TEAP
	byte[] nakTypes = {0x19}; //{0x15,0x19,0x2b,0x37};
	int eapTestInd;
	
	public void runtest() throws Exception {
		DebugInfo.debugLevel = 6;
		DebugInfo.maxDumpSize = 2000;

		sock = new EAPRadiusSocket(SharedSecretStr, userNameStr, remoteHostRaw); 
		sock.setSocketTimeout(3000);
	
	    for (eapTestInd = 0; eapTestInd < nakTypes.length; eapTestInd++) {
		    sendPacketsSequence();
	    }
	    
// close socket		
		sock.closeSocket();
	}

	int sendPacketsSequence() {
		int res = 0;

// send first message		
		DebugInfo.printMessage(1,"try create pkt1");
		
		res = sock.sendInitEAPpacket();
		if((res != 0) || (!sock.receivedData)) { 
			DebugInfo.printMessage(1,"!!! sendInitEAPpacket failed");
			sock.sendTerminatePacket();
			return 1;
		}

// send second message		
		DebugInfo.printMessageWithSeparator(1,"try create pkt2");
		EAPpldBasic nakEapPkt = new EAPpldBasic();
		nakEapPkt.code = EAPcode.EAP_CODE_RESPONSE;
		nakEapPkt.identifier = sock.getReceivedEAPPacket().identifier;
		nakEapPkt.type = EAPtype.EAP_TYPE_NAK;
		byte[] nakCurTypes = new byte[1];
		nakCurTypes[0] = nakTypes[eapTestInd];
		nakEapPkt.EAPmethodPld = new EAPtypePldID(nakCurTypes);
		nakEapPkt.isLengthSet = false;
		nakEapPkt.toByteArray();

		sock.setEapMessage(nakEapPkt);
		sock.sendEAPpacket();

		sock.sendTerminatePacket();
		return 0;
	}

	
}

