package ru.ispras.telecomtesk.tlsv12.HandshakeMessages.TLSExtensions;

public class HelloExtension
{
	public short type;
	public short length;
	public byte[] data; // 0..2^16-1 bytes
	
	public HelloExtension() {
		type = 0; length = 0;
	}
	public HelloExtension( int type, byte[] data) {
		this.type = (short)type; 
		this.length = (short)(data.length); 
		this.data = new byte[(short)data.length];
		System.arraycopy(data, 0, this.data, 0, (short)data.length);
	}
	public void setLength(short len) {
		length = len;
	}
	public short getSize() {
		return (short)(4 + data.length);
	}
	public byte[] toByteArray() {
		byte[] res = new byte[(short)(4 + data.length)];
		res[0] = (byte)(type >>> 8);
		res[1] = (byte)type;
		res[2] = (byte)(length >>> 8);
		res[3] = (byte)length;
		System.arraycopy(data, 0, res, 4, (short)data.length);
		return res;
	}
}
