package ru.ispras.telecomtesk.tlsv12.HandshakeMessages.TLSExtensions;

import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.SignatureAndHashAlgorithm;

public class SignatureAndHashAlgorithmExt extends HelloExtension
{
	public SignatureAndHashAlgorithm[] data; // 0..2^16-1 bytes

	public SignatureAndHashAlgorithmExt(SignatureAndHashAlgorithm[] sah) {
		type = 13; 
		data = sah;
		length = (short)(2 + 2 * data.length); 
	}
	public short getSize() {
		return (short)(6 + 2 * data.length);
	}
	public byte[] toByteArray() {
		int i = 0;
		short len = length;
		byte[] res = new byte[getSize()];
		res[i++] = (byte)(type >>> 8);
		res[i++] = (byte)type;
		res[i++] = (byte)(len >>> 8);
		res[i++] = (byte)len;
		len -= 2;
		res[i++] = (byte)(len >>> 8);
		res[i++] = (byte)len;
		for (int j=0; j < data.length; j++) {
			res[i++] = data[j].hash;
			res[i++] = data[j].signature;
		}
		return res;
	}
}
