package ru.ispras.telecomtesk.tlsv12.RecordProtocol;

import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.HashAlgorithm;
import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.SignatureAlgorithm;
import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.SignatureAndHashAlgorithm;

public final class DigitallySigned
{
	public SignatureAndHashAlgorithm alg;
	public byte[] signature = null;

	public DigitallySigned(SignatureAndHashAlgorithm alg) {
		this.alg = new SignatureAndHashAlgorithm(alg.hash, alg.signature);
	}
	public DigitallySigned(HashAlgorithm hash, SignatureAlgorithm signature) {
		this.alg = new SignatureAndHashAlgorithm(hash, signature);
	}
	public DigitallySigned(byte hash, byte signature) {
		this.alg = new SignatureAndHashAlgorithm(hash, signature);
	}
	public DigitallySigned(SignatureAndHashAlgorithm alg, byte[] signature) {
		this.alg.hash = alg.hash;
		this.alg.signature  = alg.signature;
		this.signature = signature;
	}
	public DigitallySigned(HashAlgorithm hash, SignatureAlgorithm sigalg, byte[] signature) {
		this.alg = new SignatureAndHashAlgorithm(hash, sigalg);
		this.signature = signature;
	}
	public DigitallySigned(byte hash, byte sigalg, byte[] signature) {
		this.alg = new SignatureAndHashAlgorithm(hash, sigalg);
		this.signature = signature;
	}
	public void setSignature(byte[] signature) {
		this.signature  = signature;
	}
}
