package ru.ispras.telecomtesk.tlsv12.TLSAlgorithms;

public enum BulkCipherAlgorithm { 
	bulk_null, bulk_rc4, bulk_3des, bulk_aes128, bulk_aes256; 
	
	public CipherType getCipherType(){
		switch (this){
			case bulk_null:
			case bulk_rc4:
				return CipherType.stream;
			case bulk_3des:
			case bulk_aes128:
			case bulk_aes256:
				return CipherType.block;
			default:
				return CipherType.unknown;
		}
	}

	public int getBlockSize(){
		switch (this){
			case bulk_3des:
				return 8;
			case bulk_aes128:
			case bulk_aes256:
				return 16;
			case bulk_null:
			case bulk_rc4:
			default:
				return 0;
		}
	}

	public int getIvSize(){
		switch (this){
			case bulk_3des:
				return 8;
			case bulk_aes128:
			case bulk_aes256:
				return 16;
			case bulk_null:
			case bulk_rc4:
			default:
				return 0;
		}
	}
};
