package ru.ispras.telecomtesk.tlsv12.TLSSocket;

import java.io.*;
import java.util.*;

import ru.ispras.telecomtesk.tlsv12.DebugInfo;

public class TLSSocketsList 
{
    public ArrayList<TLSServerChildSocket> childSockets;
    public int MAX_NUMBER_SOCKETS = 10;
    public int newsocks;
    public int cursockind;

    
    public TLSSocketsList() {
    	childSockets = new ArrayList();
    	newsocks = 0;
    	cursockind = -1;
    }
    
    public void add(TLSServerChildSocket sk)
    {
    	childSockets.add(sk);
    	newsocks++;
    }
    
    public boolean canAddNewSocket()
    {
    	return childSockets.size() < MAX_NUMBER_SOCKETS;
    }

    public void closeAll()
    {
    	for(int i=0; i<childSockets.size(); i++) {
    		childSockets.get(i).close();
    	}
    	childSockets.clear();
    }

    public void renew()
    {
    	closeAll();
    	newsocks = 0;
    	cursockind = -1;
    }

    public TLSResponse getResponse()
    {
   		return getResponse(cursockind);
    }

    public TLSResponse getResponse(int index)
    {
    	if((index >= 0)&&(index < childSockets.size()))
    		return childSockets.get(index).getResponse();
    	else
    		return null;
    }

    public TLSResponse getResponseNewConnection()
    {
		DebugInfo.printMessage(3,"TLSSocketsList::getResponseNewConnection: list size " + childSockets.size() + ", new connections " + newsocks);
		TLSResponse res;
		if(newsocks > 0) {
    		cursockind = childSockets.size() - newsocks;
    		newsocks--;
    		res = getResponse(cursockind);
    	}
    	else
    		res = null;

		DebugInfo.printMessage(5,"TLSSocketsList::getResponseNewConnection: return");
		return res;
}

    public void sendMessage(byte[] message) throws IOException
    {
    	if((cursockind >= 0)&&(cursockind < childSockets.size()))
    		childSockets.get(cursockind).sendMessage(message);
    	else
    		DebugInfo.printMessage(1,"Error! TLSSocketsList::sendMessage: index out of range");
    }
}