package ru.ispras.telecomtesk.tlsv12.TLSState;

import ru.ispras.telecomtesk.tlsv12.TLSAlgorithms.TLSCipherSuite;
import java.security.cert.X509Certificate;

public class TLSSession
{
	public byte[] id;
	public byte compression_method;
	public TLSCipherSuite cipher_spec;
	public X509Certificate peer_certificate;
	public byte[] master_secret = new byte[48];
	public boolean isResumable = true;
	
	public TLSSession(byte[] id, byte comp, TLSCipherSuite cipher, X509Certificate cert, byte[] secret) {
		this.id = new byte[id.length];
		System.arraycopy(id, 0, this.id, 0, id.length);
		compression_method = comp;
		cipher_spec = cipher;
		peer_certificate = cert;
		int len = 0;
		if(secret != null)
			len = secret.length >= 48 ? 48 : secret.length;
		System.arraycopy(secret, 0, master_secret, 0, len);
	}
}
